/* CYGNUS LOCAL -- entire file */
/* Prototypes for exported functions defined in generic.c
   Copyright (C) 2000 Free Software Foundation, Inc.
   Contributed by J"orn Rennecke (amylaar@redhat.com)

This file is part of GNU CC.

GNU CC is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GNU CC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU CC; see the file COPYING.  If not, write to
the Free Software Foundation, 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

extern void         risc16_expand_prologue     PARAMS ((void));
extern void         risc16_expand_epilogue     PARAMS ((void));
extern unsigned int risc16_compute_frame_size  PARAMS ((int));
extern int risc16_need_epilogue PARAMS ((void));
extern void risc16_function_epilogue PARAMS ((void));

#ifdef TREE_CODE
extern void         generic_setup_incoming_varargs PARAMS ((CUMULATIVE_ARGS, int, tree, int *));
extern const char * generic_cannot_inline_p        PARAMS ((tree));
extern int risc16_round_type_align_p PARAMS ((tree));
#endif

#ifdef RTX_CODE
extern void risc16_print_operand PARAMS ((FILE *, rtx, int));
extern void risc16_print_operand_address PARAMS ((FILE *, rtx));
int risc16_insn_length_adjustment PARAMS ((rtx, int));
const char *output_branch PARAMS ((const char *, rtx, rtx *, const char *));
void risc16_emit_compare PARAMS ((enum rtx_code));
void risc16_emit_scc PARAMS ((enum rtx_code, enum rtx_code, rtx *));
rtx risc16_split_operand PARAMS ((rtx, int, int));
void risc16_split_move PARAMS ((rtx, rtx));
void risc16_split_logical_operation PARAMS ((enum rtx_code, rtx, rtx));
void emit_hi_insn PARAMS ((rtx));
void risc16_machine_dependent_reorg PARAMS ((rtx));
int risc16_move_check PARAMS ((rtx *));
int risc16_arith_check PARAMS ((rtx *));
void force_into PARAMS ((rtx, rtx));
rtx emit_label_insn PARAMS ((rtx, rtx));
#ifdef HAVE_MACHINE_MODES
int risc16_address_cost PARAMS ((rtx, enum machine_mode));
#endif
#endif

#ifdef HAVE_MACHINE_MODES
/* Put prototypes that use 'enum machine mode' here.  */
#endif
