MACHINE=
SCRIPT_NAME=elf
OUTPUT_FORMAT="elf32-calmrisc16"
# See also `include/elf/calmrisc16.h'
# Reserve the first two bytes, to avoid allocating user variables at 0x0 -
# that can lead to spurious NULL pointers.
DATA_ADDR=0x00000002
TEXT_START_ADDR=0x400100 # 4Meg offset + 0x100 to get past trap vectors
ARCH=calmrisc16
MAXPAGESIZE=256
ENTRY=_start
EMBEDDED=yes
NOP=0x9e90
WRITABLE_RODATA=
OTHER_RELOCATING_SECTIONS='PROVIDE (__stack = 0x200000);'
