/* CPU data for calmrisc16.

THIS FILE IS MACHINE GENERATED WITH CGEN.

Copyright (C) 1996, 1997, 1998, 1999, 2000 Free Software Foundation, Inc.

This file is part of the GNU Binutils and/or GDB, the GNU debugger.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

*/

#include "sysdep.h"
#include <ctype.h>
#include <stdio.h>
#include <stdarg.h>
#include "ansidecl.h"
#include "bfd.h"
#include "symcat.h"
#include "calmrisc16-desc.h"
#include "calmrisc16-opc.h"
#include "opintl.h"
#include "libiberty.h"

/* Attributes.  */

static const CGEN_ATTR_ENTRY bool_attr[] =
{
  { "#f", 0 },
  { "#t", 1 },
  { 0, 0 }
};

static const CGEN_ATTR_ENTRY MACH_attr[] =
{
  { "base", MACH_BASE },
  { "calmrisc16", MACH_CALMRISC16 },
  { "max", MACH_MAX },
  { 0, 0 }
};

static const CGEN_ATTR_ENTRY ISA_attr[] =
{
  { "calmrisc16", ISA_CALMRISC16 },
  { "max", ISA_MAX },
  { 0, 0 }
};

const CGEN_ATTR_TABLE calmrisc16_cgen_ifield_attr_table[] =
{
  { "MACH", & MACH_attr[0], & MACH_attr[0] },
  { "VIRTUAL", &bool_attr[0], &bool_attr[0] },
  { "PCREL-ADDR", &bool_attr[0], &bool_attr[0] },
  { "ABS-ADDR", &bool_attr[0], &bool_attr[0] },
  { "RESERVED", &bool_attr[0], &bool_attr[0] },
  { "SIGN-OPT", &bool_attr[0], &bool_attr[0] },
  { "SIGNED", &bool_attr[0], &bool_attr[0] },
  { 0, 0, 0 }
};

const CGEN_ATTR_TABLE calmrisc16_cgen_hardware_attr_table[] =
{
  { "MACH", & MACH_attr[0], & MACH_attr[0] },
  { "VIRTUAL", &bool_attr[0], &bool_attr[0] },
  { "CACHE-ADDR", &bool_attr[0], &bool_attr[0] },
  { "PC", &bool_attr[0], &bool_attr[0] },
  { "PROFILE", &bool_attr[0], &bool_attr[0] },
  { 0, 0, 0 }
};

const CGEN_ATTR_TABLE calmrisc16_cgen_operand_attr_table[] =
{
  { "MACH", & MACH_attr[0], & MACH_attr[0] },
  { "VIRTUAL", &bool_attr[0], &bool_attr[0] },
  { "PCREL-ADDR", &bool_attr[0], &bool_attr[0] },
  { "ABS-ADDR", &bool_attr[0], &bool_attr[0] },
  { "SIGN-OPT", &bool_attr[0], &bool_attr[0] },
  { "SIGNED", &bool_attr[0], &bool_attr[0] },
  { "NEGATIVE", &bool_attr[0], &bool_attr[0] },
  { "RELAX", &bool_attr[0], &bool_attr[0] },
  { "SEM-ONLY", &bool_attr[0], &bool_attr[0] },
  { 0, 0, 0 }
};

const CGEN_ATTR_TABLE calmrisc16_cgen_insn_attr_table[] =
{
  { "MACH", & MACH_attr[0], & MACH_attr[0] },
  { "ALIAS", &bool_attr[0], &bool_attr[0] },
  { "VIRTUAL", &bool_attr[0], &bool_attr[0] },
  { "UNCOND-CTI", &bool_attr[0], &bool_attr[0] },
  { "COND-CTI", &bool_attr[0], &bool_attr[0] },
  { "SKIP-CTI", &bool_attr[0], &bool_attr[0] },
  { "DELAY-SLOT", &bool_attr[0], &bool_attr[0] },
  { "RELAXABLE", &bool_attr[0], &bool_attr[0] },
  { "RELAX", &bool_attr[0], &bool_attr[0] },
  { "NO-DIS", &bool_attr[0], &bool_attr[0] },
  { "PBB", &bool_attr[0], &bool_attr[0] },
  { "NOT-IN-DELAY-SLOT", &bool_attr[0], &bool_attr[0] },
  { 0, 0, 0 }
};

/* Instruction set variants.  */

static const CGEN_ISA calmrisc16_cgen_isa_table[] = {
  { "calmrisc16", 16, 16, 16, 32 },
  { 0, 0, 0, 0, 0 }
};

/* Machine variants.  */

static const CGEN_MACH calmrisc16_cgen_mach_table[] = {
  { "calmrisc16", "calmrisc16", MACH_CALMRISC16 },
  { 0, 0, 0 }
};

static CGEN_KEYWORD_ENTRY calmrisc16_cgen_opval_gr_names_entries[] =
{
  { "r0", 0, {0, {0}}, 0, 0 },
  { "r1", 1, {0, {0}}, 0, 0 },
  { "r2", 2, {0, {0}}, 0, 0 },
  { "r3", 3, {0, {0}}, 0, 0 },
  { "r4", 4, {0, {0}}, 0, 0 },
  { "r5", 5, {0, {0}}, 0, 0 },
  { "r6", 6, {0, {0}}, 0, 0 },
  { "r7", 7, {0, {0}}, 0, 0 },
  { "r8", 8, {0, {0}}, 0, 0 },
  { "r9", 9, {0, {0}}, 0, 0 },
  { "r10", 10, {0, {0}}, 0, 0 },
  { "r11", 11, {0, {0}}, 0, 0 },
  { "r12", 12, {0, {0}}, 0, 0 },
  { "r13", 13, {0, {0}}, 0, 0 },
  { "r14", 14, {0, {0}}, 0, 0 },
  { "r15", 15, {0, {0}}, 0, 0 }
};

CGEN_KEYWORD calmrisc16_cgen_opval_gr_names =
{
  & calmrisc16_cgen_opval_gr_names_entries[0],
  16,
  0, 0, 0, 0
};

static CGEN_KEYWORD_ENTRY calmrisc16_cgen_opval_er_names_entries[] =
{
  { "e8", 8, {0, {0}}, 0, 0 },
  { "e9", 9, {0, {0}}, 0, 0 },
  { "e10", 10, {0, {0}}, 0, 0 },
  { "e11", 11, {0, {0}}, 0, 0 },
  { "e12", 12, {0, {0}}, 0, 0 },
  { "e13", 13, {0, {0}}, 0, 0 },
  { "e14", 14, {0, {0}}, 0, 0 },
  { "e15", 15, {0, {0}}, 0, 0 }
};

CGEN_KEYWORD calmrisc16_cgen_opval_er_names =
{
  & calmrisc16_cgen_opval_er_names_entries[0],
  8,
  0, 0, 0, 0
};

static CGEN_KEYWORD_ENTRY calmrisc16_cgen_opval_ar_names_entries[] =
{
  { "lr", 14, {0, {0}}, 0, 0 },
  { "sp", 15, {0, {0}}, 0, 0 },
  { "a8", 8, {0, {0}}, 0, 0 },
  { "a9", 9, {0, {0}}, 0, 0 },
  { "a10", 10, {0, {0}}, 0, 0 },
  { "a11", 11, {0, {0}}, 0, 0 },
  { "a12", 12, {0, {0}}, 0, 0 },
  { "a13", 13, {0, {0}}, 0, 0 },
  { "a14", 14, {0, {0}}, 0, 0 },
  { "a15", 15, {0, {0}}, 0, 0 }
};

CGEN_KEYWORD calmrisc16_cgen_opval_ar_names =
{
  & calmrisc16_cgen_opval_ar_names_entries[0],
  10,
  0, 0, 0, 0
};

static CGEN_KEYWORD_ENTRY calmrisc16_cgen_opval_spr_names_entries[] =
{
  { "spcl_fiq", 0, {0, {0}}, 0, 0 },
  { "spch_fiq", 1, {0, {0}}, 0, 0 },
  { "ssr_fiq", 2, {0, {0}}, 0, 0 },
  { "spcl_irq", 4, {0, {0}}, 0, 0 },
  { "spch_irq", 5, {0, {0}}, 0, 0 },
  { "ssr_irq", 6, {0, {0}}, 0, 0 },
  { "ssr_swi", 10, {0, {0}}, 0, 0 }
};

CGEN_KEYWORD calmrisc16_cgen_opval_spr_names =
{
  & calmrisc16_cgen_opval_spr_names_entries[0],
  7,
  0, 0, 0, 0
};

static CGEN_KEYWORD_ENTRY calmrisc16_cgen_opval_h_r0_entries[] =
{
  { "r0", 0, {0, {0}}, 0, 0 }
};

CGEN_KEYWORD calmrisc16_cgen_opval_h_r0 =
{
  & calmrisc16_cgen_opval_h_r0_entries[0],
  1,
  0, 0, 0, 0
};

static CGEN_KEYWORD_ENTRY calmrisc16_cgen_opval_h_r1_entries[] =
{
  { "r1", 1, {0, {0}}, 0, 0 }
};

CGEN_KEYWORD calmrisc16_cgen_opval_h_r1 =
{
  & calmrisc16_cgen_opval_h_r1_entries[0],
  1,
  0, 0, 0, 0
};

static CGEN_KEYWORD_ENTRY calmrisc16_cgen_opval_h_a8_entries[] =
{
  { "a8", 8, {0, {0}}, 0, 0 }
};

CGEN_KEYWORD calmrisc16_cgen_opval_h_a8 =
{
  & calmrisc16_cgen_opval_h_a8_entries[0],
  1,
  0, 0, 0, 0
};

static CGEN_KEYWORD_ENTRY calmrisc16_cgen_opval_h_a14_entries[] =
{
  { "a14", 14, {0, {0}}, 0, 0 }
};

CGEN_KEYWORD calmrisc16_cgen_opval_h_a14 =
{
  & calmrisc16_cgen_opval_h_a14_entries[0],
  1,
  0, 0, 0, 0
};

static CGEN_KEYWORD_ENTRY calmrisc16_cgen_opval_h_a15_entries[] =
{
  { "sp", 0, {0, {0}}, 0, 0 },
  { "a15", 0, {0, {0}}, 0, 0 }
};

CGEN_KEYWORD calmrisc16_cgen_opval_h_a15 =
{
  & calmrisc16_cgen_opval_h_a15_entries[0],
  2,
  0, 0, 0, 0
};

static CGEN_KEYWORD_ENTRY calmrisc16_cgen_opval_h_spcl_fiq_entries[] =
{
  { "spcl_fiq", 0, {0, {0}}, 0, 0 }
};

CGEN_KEYWORD calmrisc16_cgen_opval_h_spcl_fiq =
{
  & calmrisc16_cgen_opval_h_spcl_fiq_entries[0],
  1,
  0, 0, 0, 0
};

static CGEN_KEYWORD_ENTRY calmrisc16_cgen_opval_h_spch_fiq_entries[] =
{
  { "spch_fiq", 1, {0, {0}}, 0, 0 }
};

CGEN_KEYWORD calmrisc16_cgen_opval_h_spch_fiq =
{
  & calmrisc16_cgen_opval_h_spch_fiq_entries[0],
  1,
  0, 0, 0, 0
};

static CGEN_KEYWORD_ENTRY calmrisc16_cgen_opval_h_ssr_fiq_entries[] =
{
  { "ssr_fiq", 2, {0, {0}}, 0, 0 }
};

CGEN_KEYWORD calmrisc16_cgen_opval_h_ssr_fiq =
{
  & calmrisc16_cgen_opval_h_ssr_fiq_entries[0],
  1,
  0, 0, 0, 0
};

static CGEN_KEYWORD_ENTRY calmrisc16_cgen_opval_h_spcl_irq_entries[] =
{
  { "spcl_irq", 4, {0, {0}}, 0, 0 }
};

CGEN_KEYWORD calmrisc16_cgen_opval_h_spcl_irq =
{
  & calmrisc16_cgen_opval_h_spcl_irq_entries[0],
  1,
  0, 0, 0, 0
};

static CGEN_KEYWORD_ENTRY calmrisc16_cgen_opval_h_spch_irq_entries[] =
{
  { "spch_irq", 5, {0, {0}}, 0, 0 }
};

CGEN_KEYWORD calmrisc16_cgen_opval_h_spch_irq =
{
  & calmrisc16_cgen_opval_h_spch_irq_entries[0],
  1,
  0, 0, 0, 0
};

static CGEN_KEYWORD_ENTRY calmrisc16_cgen_opval_h_ssr_irq_entries[] =
{
  { "ssr_irq", 6, {0, {0}}, 0, 0 }
};

CGEN_KEYWORD calmrisc16_cgen_opval_h_ssr_irq =
{
  & calmrisc16_cgen_opval_h_ssr_irq_entries[0],
  1,
  0, 0, 0, 0
};

static CGEN_KEYWORD_ENTRY calmrisc16_cgen_opval_h_ssr_swi_entries[] =
{
  { "ssr_swi", 10, {0, {0}}, 0, 0 }
};

CGEN_KEYWORD calmrisc16_cgen_opval_h_ssr_swi =
{
  & calmrisc16_cgen_opval_h_ssr_swi_entries[0],
  1,
  0, 0, 0, 0
};

static CGEN_KEYWORD_ENTRY calmrisc16_cgen_opval_h_sr_entries[] =
{
  { "sr", 0, {0, {0}}, 0, 0 }
};

CGEN_KEYWORD calmrisc16_cgen_opval_h_sr =
{
  & calmrisc16_cgen_opval_h_sr_entries[0],
  1,
  0, 0, 0, 0
};

static CGEN_KEYWORD_ENTRY calmrisc16_cgen_opval_h_ec2_entries[] =
{
  { "ec0", 0, {0, {0}}, 0, 0 },
  { "ec1", 1, {0, {0}}, 0, 0 },
  { "ec2", 2, {0, {0}}, 0, 0 },
  { "ec3", 3, {0, {0}}, 0, 0 }
};

CGEN_KEYWORD calmrisc16_cgen_opval_h_ec2 =
{
  & calmrisc16_cgen_opval_h_ec2_entries[0],
  4,
  0, 0, 0, 0
};


/* The hardware table.  */

#if defined (__STDC__) || defined (ALMOST_STDC) || defined (HAVE_STRINGIZE)
#define A(a) (1 << CGEN_HW_##a)
#else
#define A(a) (1 << CGEN_HW_/**/a)
#endif

const CGEN_HW_ENTRY calmrisc16_cgen_hw_table[] =
{
  { "h-memory", HW_H_MEMORY, CGEN_ASM_NONE, 0, { 0, { (1<<MACH_BASE) } } },
  { "h-sint", HW_H_SINT, CGEN_ASM_NONE, 0, { 0, { (1<<MACH_BASE) } } },
  { "h-uint", HW_H_UINT, CGEN_ASM_NONE, 0, { 0, { (1<<MACH_BASE) } } },
  { "h-addr", HW_H_ADDR, CGEN_ASM_NONE, 0, { 0, { (1<<MACH_BASE) } } },
  { "h-iaddr", HW_H_IADDR, CGEN_ASM_NONE, 0, { 0, { (1<<MACH_BASE) } } },
  { "h-pc", HW_H_PC, CGEN_ASM_NONE, 0, { 0|A(PROFILE)|A(PC), { (1<<MACH_BASE) } } },
  { "h-gr", HW_H_GR, CGEN_ASM_KEYWORD, (PTR) & calmrisc16_cgen_opval_gr_names, { 0|A(CACHE_ADDR)|A(PROFILE), { (1<<MACH_BASE) } } },
  { "h-r0", HW_H_R0, CGEN_ASM_KEYWORD, (PTR) & calmrisc16_cgen_opval_h_r0, { 0|A(VIRTUAL), { (1<<MACH_BASE) } } },
  { "h-r1", HW_H_R1, CGEN_ASM_KEYWORD, (PTR) & calmrisc16_cgen_opval_h_r1, { 0|A(VIRTUAL), { (1<<MACH_BASE) } } },
  { "h-er", HW_H_ER, CGEN_ASM_KEYWORD, (PTR) & calmrisc16_cgen_opval_er_names, { 0, { (1<<MACH_BASE) } } },
  { "h-ar", HW_H_AR, CGEN_ASM_KEYWORD, (PTR) & calmrisc16_cgen_opval_ar_names, { 0|A(VIRTUAL), { (1<<MACH_BASE) } } },
  { "h-a8", HW_H_A8, CGEN_ASM_KEYWORD, (PTR) & calmrisc16_cgen_opval_h_a8, { 0|A(VIRTUAL), { (1<<MACH_BASE) } } },
  { "h-a14", HW_H_A14, CGEN_ASM_KEYWORD, (PTR) & calmrisc16_cgen_opval_h_a14, { 0|A(VIRTUAL), { (1<<MACH_BASE) } } },
  { "h-a15", HW_H_A15, CGEN_ASM_KEYWORD, (PTR) & calmrisc16_cgen_opval_h_a15, { 0|A(VIRTUAL), { (1<<MACH_BASE) } } },
  { "h-spr", HW_H_SPR, CGEN_ASM_KEYWORD, (PTR) & calmrisc16_cgen_opval_spr_names, { 0|A(CACHE_ADDR)|A(PROFILE), { (1<<MACH_BASE) } } },
  { "h-spcl-fiq", HW_H_SPCL_FIQ, CGEN_ASM_KEYWORD, (PTR) & calmrisc16_cgen_opval_h_spcl_fiq, { 0|A(VIRTUAL), { (1<<MACH_BASE) } } },
  { "h-spch-fiq", HW_H_SPCH_FIQ, CGEN_ASM_KEYWORD, (PTR) & calmrisc16_cgen_opval_h_spch_fiq, { 0|A(VIRTUAL), { (1<<MACH_BASE) } } },
  { "h-ssr-fiq", HW_H_SSR_FIQ, CGEN_ASM_KEYWORD, (PTR) & calmrisc16_cgen_opval_h_ssr_fiq, { 0|A(VIRTUAL), { (1<<MACH_BASE) } } },
  { "h-spcl-irq", HW_H_SPCL_IRQ, CGEN_ASM_KEYWORD, (PTR) & calmrisc16_cgen_opval_h_spcl_irq, { 0|A(VIRTUAL), { (1<<MACH_BASE) } } },
  { "h-spch-irq", HW_H_SPCH_IRQ, CGEN_ASM_KEYWORD, (PTR) & calmrisc16_cgen_opval_h_spch_irq, { 0|A(VIRTUAL), { (1<<MACH_BASE) } } },
  { "h-ssr-irq", HW_H_SSR_IRQ, CGEN_ASM_KEYWORD, (PTR) & calmrisc16_cgen_opval_h_ssr_irq, { 0|A(VIRTUAL), { (1<<MACH_BASE) } } },
  { "h-ssr-swi", HW_H_SSR_SWI, CGEN_ASM_KEYWORD, (PTR) & calmrisc16_cgen_opval_h_ssr_swi, { 0|A(VIRTUAL), { (1<<MACH_BASE) } } },
  { "h-t", HW_H_T, CGEN_ASM_NONE, 0, { 0, { (1<<MACH_BASE) } } },
  { "h-z1", HW_H_Z1, CGEN_ASM_NONE, 0, { 0, { (1<<MACH_BASE) } } },
  { "h-z0", HW_H_Z0, CGEN_ASM_NONE, 0, { 0, { (1<<MACH_BASE) } } },
  { "h-v", HW_H_V, CGEN_ASM_NONE, 0, { 0, { (1<<MACH_BASE) } } },
  { "h-pm", HW_H_PM, CGEN_ASM_NONE, 0, { 0, { (1<<MACH_BASE) } } },
  { "h-te", HW_H_TE, CGEN_ASM_NONE, 0, { 0, { (1<<MACH_BASE) } } },
  { "h-ie", HW_H_IE, CGEN_ASM_NONE, 0, { 0, { (1<<MACH_BASE) } } },
  { "h-fe", HW_H_FE, CGEN_ASM_NONE, 0, { 0, { (1<<MACH_BASE) } } },
  { "h-sr", HW_H_SR, CGEN_ASM_KEYWORD, (PTR) & calmrisc16_cgen_opval_h_sr, { 0|A(VIRTUAL), { (1<<MACH_BASE) } } },
  { "h-ec2", HW_H_EC2, CGEN_ASM_KEYWORD, (PTR) & calmrisc16_cgen_opval_h_ec2, { 0|A(VIRTUAL), { (1<<MACH_BASE) } } },
  { 0, 0, CGEN_ASM_NONE, 0, {0, {0}} }
};

#undef A


/* The instruction field table.  */

#if defined (__STDC__) || defined (ALMOST_STDC) || defined (HAVE_STRINGIZE)
#define A(a) (1 << CGEN_IFLD_##a)
#else
#define A(a) (1 << CGEN_IFLD_/**/a)
#endif

const CGEN_IFLD calmrisc16_cgen_ifld_table[] =
{
  { CALMRISC16_F_NIL, "f-nil", 0, 0, 0, 0, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_ANYOF, "f-anyof", 0, 0, 0, 0, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_OP1, "f-op1", 0, 16, 0, 4, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_OP2, "f-op2", 0, 16, 4, 4, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_OP3, "f-op3", 0, 16, 8, 4, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_OP4, "f-op4", 0, 16, 12, 4, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_OP0_3, "f-op0-3", 0, 16, 0, 3, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_OP4_1, "f-op4-1", 0, 16, 4, 1, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_OP4_3, "f-op4-3", 0, 16, 4, 3, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_OP8_1, "f-op8-1", 0, 16, 8, 1, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_OP8_2, "f-op8-2", 0, 16, 8, 2, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_OP8_3, "f-op8-3", 0, 16, 8, 3, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_OP9_1, "f-op9-1", 0, 16, 9, 1, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_OP12_1, "f-op12-1", 0, 16, 12, 1, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_RN, "f-Rn", 0, 16, 4, 4, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_RN1, "f-Rn1", 0, 16, 12, 4, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_RM, "f-Rm", 0, 16, 12, 4, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_DN, "f-Dn", 0, 16, 5, 3, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_DN1, "f-Dn1", 0, 16, 13, 3, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_H, "f-H", 0, 16, 7, 1, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_RLIST_RM, "f-Rlist-Rm", 0, 16, 4, 4, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_RLIST_RN, "f-Rlist-Rn", 0, 16, 13, 3, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_EN, "f-En", 0, 16, 13, 3, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_AN, "f-An", 0, 16, 5, 3, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_AN1, "f-An1", 0, 16, 13, 3, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_AN2, "f-An2", 0, 16, 9, 3, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_ALIST_AM, "f-Alist-Am", 0, 16, 5, 3, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_ALIST_AN, "f-Alist-An", 0, 16, 13, 3, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_RS, "f-Rs", 0, 16, 12, 4, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_IMM5, "f-imm5", 0, 16, 11, 5, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_IMM5C, "f-imm5c", 0, 16, 7, 5, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_IMM6, "f-imm6", 0, 16, 10, 6, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_IMM7, "f-imm7", 0, 16, 9, 7, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_IMM8, "f-imm8", 0, 16, 8, 8, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_IMM13, "f-imm13", 0, 16, 3, 13, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_IMM16, "f-imm16", 16, 16, 0, 16, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_IMM22, "f-imm22", 0, 32, 10, 22, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_DISP4, "f-disp4", 0, 16, 12, 4, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_DISP8, "f-disp8", 0, 16, 8, 8, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_EOFFSET8, "f-eoffset8", 0, 16, 9, 7, { 0|A(PCREL_ADDR), { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_EOFFSET11, "f-eoffset11", 0, 16, 6, 10, { 0|A(PCREL_ADDR), { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_EOFFSET13, "f-eoffset13", 0, 16, 4, 12, { 0|A(PCREL_ADDR), { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_EDISP5, "f-edisp5", 0, 16, 12, 4, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_EDISP9, "f-edisp9", 0, 16, 8, 8, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_DISP16, "f-disp16", 16, 16, 0, 16, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_CMODE1, "f-cmode1", 0, 16, 9, 3, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_CMODE2, "f-cmode2", 0, 16, 5, 3, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_BMODE, "f-bmode", 0, 16, 3, 2, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_D, "f-d", 0, 16, 5, 1, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_BS3, "f-bs3", 0, 16, 13, 3, { 0, { (1<<MACH_BASE) } }  },
  { CALMRISC16_F_EC2, "f-ec2", 0, 16, 7, 2, { 0, { (1<<MACH_BASE) } }  },
  { 0, 0, 0, 0, 0, 0, {0, {0}} }
};

#undef A


/* The operand table.  */

#if defined (__STDC__) || defined (ALMOST_STDC) || defined (HAVE_STRINGIZE)
#define A(a) (1 << CGEN_OPERAND_##a)
#else
#define A(a) (1 << CGEN_OPERAND_/**/a)
#endif
#if defined (__STDC__) || defined (ALMOST_STDC) || defined (HAVE_STRINGIZE)
#define OPERAND(op) CALMRISC16_OPERAND_##op
#else
#define OPERAND(op) CALMRISC16_OPERAND_/**/op
#endif

const CGEN_OPERAND calmrisc16_cgen_operand_table[] =
{
/* pc: program counter */
  { "pc", CALMRISC16_OPERAND_PC, HW_H_PC, 0, 0,
    { 0|A(SEM_ONLY), { (1<<MACH_BASE) } }  },
/* Rn: general register */
  { "Rn", CALMRISC16_OPERAND_RN, HW_H_GR, 4, 4,
    { 0, { (1<<MACH_BASE) } }  },
/* Rn1: general register */
  { "Rn1", CALMRISC16_OPERAND_RN1, HW_H_GR, 12, 4,
    { 0, { (1<<MACH_BASE) } }  },
/* Ri: general register */
  { "Ri", CALMRISC16_OPERAND_RI, HW_H_GR, 12, 4,
    { 0, { (1<<MACH_BASE) } }  },
/* Ri1: general register */
  { "Ri1", CALMRISC16_OPERAND_RI1, HW_H_GR, 4, 4,
    { 0, { (1<<MACH_BASE) } }  },
/* Rj: general register */
  { "Rj", CALMRISC16_OPERAND_RJ, HW_H_GR, 12, 4,
    { 0, { (1<<MACH_BASE) } }  },
/* Rm: general register */
  { "Rm", CALMRISC16_OPERAND_RM, HW_H_GR, 12, 4,
    { 0, { (1<<MACH_BASE) } }  },
/* Dn: general registers r0-r7 */
  { "Dn", CALMRISC16_OPERAND_DN, HW_H_GR, 5, 3,
    { 0, { (1<<MACH_BASE) } }  },
/* Dn1: general registers r0-r7 */
  { "Dn1", CALMRISC16_OPERAND_DN1, HW_H_GR, 13, 3,
    { 0, { (1<<MACH_BASE) } }  },
/* Di: general registers r0-r7 */
  { "Di", CALMRISC16_OPERAND_DI, HW_H_GR, 5, 3,
    { 0, { (1<<MACH_BASE) } }  },
/* Di1: general registers r0-r7 */
  { "Di1", CALMRISC16_OPERAND_DI1, HW_H_GR, 13, 3,
    { 0, { (1<<MACH_BASE) } }  },
/* H: r6 or r7 for bnzd */
  { "H", CALMRISC16_OPERAND_H, HW_H_GR, 7, 1,
    { 0, { (1<<MACH_BASE) } }  },
/* Rlist: General register list for the push insn */
  { "Rlist", CALMRISC16_OPERAND_RLIST, HW_H_UINT, 4, 7,
    { 0|A(VIRTUAL), { (1<<MACH_BASE) } }  },
/* En: extension registers e8-e15 */
  { "En", CALMRISC16_OPERAND_EN, HW_H_ER, 13, 3,
    { 0, { (1<<MACH_BASE) } }  },
/* Ei: extension registers e8-e15 */
  { "Ei", CALMRISC16_OPERAND_EI, HW_H_ER, 13, 3,
    { 0, { (1<<MACH_BASE) } }  },
/* An: address register */
  { "An", CALMRISC16_OPERAND_AN, HW_H_AR, 5, 3,
    { 0, { (1<<MACH_BASE) } }  },
/* An1: address register */
  { "An1", CALMRISC16_OPERAND_AN1, HW_H_AR, 13, 3,
    { 0, { (1<<MACH_BASE) } }  },
/* An2: address register */
  { "An2", CALMRISC16_OPERAND_AN2, HW_H_AR, 9, 3,
    { 0, { (1<<MACH_BASE) } }  },
/* Ai: address register */
  { "Ai", CALMRISC16_OPERAND_AI, HW_H_AR, 13, 3,
    { 0, { (1<<MACH_BASE) } }  },
/* Ai1: address register */
  { "Ai1", CALMRISC16_OPERAND_AI1, HW_H_AR, 9, 3,
    { 0, { (1<<MACH_BASE) } }  },
/* Alist: Address register list for the push insn */
  { "Alist", CALMRISC16_OPERAND_ALIST, HW_H_UINT, 5, 6,
    { 0|A(VIRTUAL), { (1<<MACH_BASE) } }  },
/* Rs: special register */
  { "Rs", CALMRISC16_OPERAND_RS, HW_H_SPR, 12, 4,
    { 0, { (1<<MACH_BASE) } }  },
/* imm5c: 5  bit unsigned immediate */
  { "imm5c", CALMRISC16_OPERAND_IMM5C, HW_H_UINT, 7, 5,
    { 0, { (1<<MACH_BASE) } }  },
/* imm22: 22 bit address */
  { "imm22", CALMRISC16_OPERAND_IMM22, HW_H_UINT, 10, 22,
    { 0, { (1<<MACH_BASE) } }  },
/* eimm22: 22 bit unsigned immediate or 22 bit negative immediate */
  { "eimm22", CALMRISC16_OPERAND_EIMM22, HW_H_UINT, 10, 22,
    { 0, { (1<<MACH_BASE) } }  },
/* imm5: 5 bit unsigned immediate */
  { "imm5", CALMRISC16_OPERAND_IMM5, HW_H_UINT, 11, 5,
    { 0, { (1<<MACH_BASE) } }  },
/* imm6: 6 bit unsigned immediate */
  { "imm6", CALMRISC16_OPERAND_IMM6, HW_H_UINT, 10, 6,
    { 0, { (1<<MACH_BASE) } }  },
/* imm7: 7 bit unsigned immediate */
  { "imm7", CALMRISC16_OPERAND_IMM7, HW_H_UINT, 9, 7,
    { 0, { (1<<MACH_BASE) } }  },
/* imm8: 8 bit unsigned immediate */
  { "imm8", CALMRISC16_OPERAND_IMM8, HW_H_UINT, 8, 8,
    { 0, { (1<<MACH_BASE) } }  },
/* imm16: 16 bit unsigned immediate */
  { "imm16", CALMRISC16_OPERAND_IMM16, HW_H_UINT, 0, 16,
    { 0, { (1<<MACH_BASE) } }  },
/* eimm16: 16 bit unsigned immediate or 16 bit negative immediate */
  { "eimm16", CALMRISC16_OPERAND_EIMM16, HW_H_UINT, 0, 16,
    { 0, { (1<<MACH_BASE) } }  },
/* imm13: 13 bit unsigned immediate */
  { "imm13", CALMRISC16_OPERAND_IMM13, HW_H_UINT, 3, 13,
    { 0, { (1<<MACH_BASE) } }  },
/* elabel8:  8 bit pc relative address */
  { "elabel8", CALMRISC16_OPERAND_ELABEL8, HW_H_IADDR, 9, 7,
    { 0|A(PCREL_ADDR), { (1<<MACH_BASE) } }  },
/* elabel11: 11 bit pc relative address */
  { "elabel11", CALMRISC16_OPERAND_ELABEL11, HW_H_IADDR, 6, 10,
    { 0|A(PCREL_ADDR), { (1<<MACH_BASE) } }  },
/* elabel13: 13 bit pc relative address */
  { "elabel13", CALMRISC16_OPERAND_ELABEL13, HW_H_IADDR, 4, 12,
    { 0|A(PCREL_ADDR), { (1<<MACH_BASE) } }  },
/* disp4: 4 bit unsigned offset */
  { "disp4", CALMRISC16_OPERAND_DISP4, HW_H_UINT, 12, 4,
    { 0, { (1<<MACH_BASE) } }  },
/* disp8: 8 bit unsigned offset */
  { "disp8", CALMRISC16_OPERAND_DISP8, HW_H_UINT, 8, 8,
    { 0, { (1<<MACH_BASE) } }  },
/* edisp5: 5 bit unsigned offset */
  { "edisp5", CALMRISC16_OPERAND_EDISP5, HW_H_UINT, 12, 4,
    { 0, { (1<<MACH_BASE) } }  },
/* edisp9: 9 bit unsigned offset */
  { "edisp9", CALMRISC16_OPERAND_EDISP9, HW_H_UINT, 8, 8,
    { 0, { (1<<MACH_BASE) } }  },
/* disp16: 16 bit unsigned offset */
  { "disp16", CALMRISC16_OPERAND_DISP16, HW_H_UINT, 0, 16,
    { 0, { (1<<MACH_BASE) } }  },
/* bs3: 3 bit bit selector */
  { "bs3", CALMRISC16_OPERAND_BS3, HW_H_UINT, 13, 3,
    { 0, { (1<<MACH_BASE) } }  },
/* ec2: 2 bit external condition */
  { "ec2", CALMRISC16_OPERAND_EC2, HW_H_EC2, 7, 2,
    { 0, { (1<<MACH_BASE) } }  },
/* t: true            bit */
  { "t", CALMRISC16_OPERAND_T, HW_H_T, 0, 0,
    { 0|A(SEM_ONLY), { (1<<MACH_BASE) } }  },
/* pm: privileged mode bit */
  { "pm", CALMRISC16_OPERAND_PM, HW_H_PM, 0, 0,
    { 0|A(SEM_ONLY), { (1<<MACH_BASE) } }  },
/* z1: zero            bit */
  { "z1", CALMRISC16_OPERAND_Z1, HW_H_Z1, 0, 0,
    { 0|A(SEM_ONLY), { (1<<MACH_BASE) } }  },
/* z0: zero            bit */
  { "z0", CALMRISC16_OPERAND_Z0, HW_H_Z0, 0, 0,
    { 0|A(SEM_ONLY), { (1<<MACH_BASE) } }  },
/* v: overflow        bit */
  { "v", CALMRISC16_OPERAND_V, HW_H_V, 0, 0,
    { 0|A(SEM_ONLY), { (1<<MACH_BASE) } }  },
/* te: TRQ enable      bit */
  { "te", CALMRISC16_OPERAND_TE, HW_H_TE, 0, 0,
    { 0|A(SEM_ONLY), { (1<<MACH_BASE) } }  },
/* ie: IRQ enable      bit */
  { "ie", CALMRISC16_OPERAND_IE, HW_H_IE, 0, 0,
    { 0|A(SEM_ONLY), { (1<<MACH_BASE) } }  },
/* fe: FIQ enable      bit */
  { "fe", CALMRISC16_OPERAND_FE, HW_H_FE, 0, 0,
    { 0|A(SEM_ONLY), { (1<<MACH_BASE) } }  },
/* sr: Hard register sr */
  { "sr", CALMRISC16_OPERAND_SR, HW_H_SR, 0, 0,
    { 0|A(SEM_ONLY), { (1<<MACH_BASE) } }  },
/* r0: Hard register r0 */
  { "r0", CALMRISC16_OPERAND_R0, HW_H_R0, 0, 0,
    { 0|A(SEM_ONLY), { (1<<MACH_BASE) } }  },
/* r1: Hard register r1 */
  { "r1", CALMRISC16_OPERAND_R1, HW_H_R1, 0, 0,
    { 0|A(SEM_ONLY), { (1<<MACH_BASE) } }  },
/* a8: Hard register a8 */
  { "a8", CALMRISC16_OPERAND_A8, HW_H_A8, 0, 0,
    { 0|A(SEM_ONLY), { (1<<MACH_BASE) } }  },
/* a14: Hard register a14 */
  { "a14", CALMRISC16_OPERAND_A14, HW_H_A14, 0, 0,
    { 0|A(SEM_ONLY), { (1<<MACH_BASE) } }  },
/* sp: Hard register sp */
  { "sp", CALMRISC16_OPERAND_SP, HW_H_A15, 0, 0,
    { 0, { (1<<MACH_BASE) } }  },
/* spcl-fiq: Hard register spcl-fiq */
  { "spcl-fiq", CALMRISC16_OPERAND_SPCL_FIQ, HW_H_SPCL_FIQ, 0, 0,
    { 0|A(SEM_ONLY), { (1<<MACH_BASE) } }  },
/* spch-fiq: Hard register spch-fiq */
  { "spch-fiq", CALMRISC16_OPERAND_SPCH_FIQ, HW_H_SPCH_FIQ, 0, 0,
    { 0|A(SEM_ONLY), { (1<<MACH_BASE) } }  },
/* ssr-fiq: Hard register ssr-fiq */
  { "ssr-fiq", CALMRISC16_OPERAND_SSR_FIQ, HW_H_SSR_FIQ, 0, 0,
    { 0|A(SEM_ONLY), { (1<<MACH_BASE) } }  },
/* spcl-irq: Hard register spcl-irq */
  { "spcl-irq", CALMRISC16_OPERAND_SPCL_IRQ, HW_H_SPCL_IRQ, 0, 0,
    { 0|A(SEM_ONLY), { (1<<MACH_BASE) } }  },
/* spch-irq: Hard register spch-irq */
  { "spch-irq", CALMRISC16_OPERAND_SPCH_IRQ, HW_H_SPCH_IRQ, 0, 0,
    { 0|A(SEM_ONLY), { (1<<MACH_BASE) } }  },
/* ssr-irq: Hard register ssr-irq */
  { "ssr-irq", CALMRISC16_OPERAND_SSR_IRQ, HW_H_SSR_IRQ, 0, 0,
    { 0|A(SEM_ONLY), { (1<<MACH_BASE) } }  },
/* ssr-swi: Hard register ssr-swi */
  { "ssr-swi", CALMRISC16_OPERAND_SSR_SWI, HW_H_SSR_SWI, 0, 0,
    { 0|A(SEM_ONLY), { (1<<MACH_BASE) } }  },
  { 0, 0, 0, 0, 0, {0, {0}} }
};

#undef A


/* The instruction table.  */

#define OP(field) CGEN_SYNTAX_MAKE_FIELD (OPERAND (field))
#if defined (__STDC__) || defined (ALMOST_STDC) || defined (HAVE_STRINGIZE)
#define A(a) (1 << CGEN_INSN_##a)
#else
#define A(a) (1 << CGEN_INSN_/**/a)
#endif

static const CGEN_IBASE calmrisc16_cgen_insn_table[MAX_INSNS] =
{
  /* Special null first entry.
     A `num' value of zero is thus invalid.
     Also, the special `invalid' insn resides here.  */
  { 0, 0, 0, 0, {0, {0}} },
/* clrsr fe */
  {
    CALMRISC16_INSN_CLRSRFE, "clrsrfe", "clrsr", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* setsr fe */
  {
    CALMRISC16_INSN_SETSRFE, "setsrfe", "setsr", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* tstsr fe */
  {
    CALMRISC16_INSN_TSTSRFE, "tstsrfe", "tstsr", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* clrsr ie */
  {
    CALMRISC16_INSN_CLRSRIE, "clrsrie", "clrsr", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* setsr ie */
  {
    CALMRISC16_INSN_SETSRIE, "setsrie", "setsr", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* tstsr ie */
  {
    CALMRISC16_INSN_TSTSRIE, "tstsrie", "tstsr", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* clrsr te */
  {
    CALMRISC16_INSN_CLRSRTE, "clrsrte", "clrsr", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* setsr te */
  {
    CALMRISC16_INSN_SETSRTE, "setsrte", "setsr", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* tstsr te */
  {
    CALMRISC16_INSN_TSTSRTE, "tstsrte", "tstsr", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* clrsr v */
  {
    CALMRISC16_INSN_CLRSRV, "clrsrv", "clrsr", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* setsr v */
  {
    CALMRISC16_INSN_SETSRV, "setsrv", "setsr", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* tstsr v */
  {
    CALMRISC16_INSN_TSTSRV, "tstsrv", "tstsr", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* clrsr z0 */
  {
    CALMRISC16_INSN_CLRSRZ0, "clrsrz0", "clrsr", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* setsr z0 */
  {
    CALMRISC16_INSN_SETSRZ0, "setsrz0", "setsr", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* tstsr z0 */
  {
    CALMRISC16_INSN_TSTSRZ0, "tstsrz0", "tstsr", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* clrsr z1 */
  {
    CALMRISC16_INSN_CLRSRZ1, "clrsrz1", "clrsr", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* setsr z1 */
  {
    CALMRISC16_INSN_SETSRZ1, "setsrz1", "setsr", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* tstsr z1 */
  {
    CALMRISC16_INSN_TSTSRZ1, "tstsrz1", "tstsr", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* clrsr pm */
  {
    CALMRISC16_INSN_CLRSRPM, "clrsrpm", "clrsr", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* setsr pm */
  {
    CALMRISC16_INSN_SETSRPM, "setsrpm", "setsr", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* tstsr pm */
  {
    CALMRISC16_INSN_TSTSRPM, "tstsrpm", "tstsr", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* add $Rn,$Ri */
  {
    CALMRISC16_INSN_ADDGRGR, "addgrgr", "add", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* sub $Rn,$Ri */
  {
    CALMRISC16_INSN_SUBGRGR, "subgrgr", "sub", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* adc $Rn,$Ri */
  {
    CALMRISC16_INSN_ADDGRGRC, "addgrgrc", "adc", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* sbc $Rn,$Ri */
  {
    CALMRISC16_INSN_SUBGRGRC, "subgrgrc", "sbc", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* mul uu,$Dn,$Di1 */
  {
    CALMRISC16_INSN_MULUU, "muluu", "mul", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* mul us,$Dn,$Di1 */
  {
    CALMRISC16_INSN_MULUS, "mulus", "mul", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* mul su,$Dn,$Di1 */
  {
    CALMRISC16_INSN_MULSU, "mulsu", "mul", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* mul ss,$Dn,$Di1 */
  {
    CALMRISC16_INSN_MULSS, "mulss", "mul", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* add $Rn,$imm7 */
  {
    CALMRISC16_INSN_ADDGRI7, "addgri7", "add", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* sub $Rn,$imm7 */
  {
    CALMRISC16_INSN_SUBGRI7, "subgri7", "sub", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* add $Rn1,$eimm16 */
  {
    CALMRISC16_INSN_ADDGRI16, "addgri16", "add", 32,
    { 0|A(NOT_IN_DELAY_SLOT), { (1<<MACH_BASE) } }
  },
/* adc $Rn1,$eimm16 */
  {
    CALMRISC16_INSN_ADDGRI16C, "addgri16c", "adc", 32,
    { 0|A(NOT_IN_DELAY_SLOT), { (1<<MACH_BASE) } }
  },
/* sbc $Rn1,$eimm16 */
  {
    CALMRISC16_INSN_SUBGRI16C, "subgri16c", "sbc", 32,
    { 0|A(NOT_IN_DELAY_SLOT), { (1<<MACH_BASE) } }
  },
/* add $An,$Ri */
  {
    CALMRISC16_INSN_ADDARGR, "addargr", "add", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* sub $An,$Ri */
  {
    CALMRISC16_INSN_SUBARGR, "subargr", "sub", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* add $An,$imm5 */
  {
    CALMRISC16_INSN_ADDARI5, "addari5", "add", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* sub $An,$imm5 */
  {
    CALMRISC16_INSN_SUBARI5, "subari5", "sub", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* add $An1,$imm16 */
  {
    CALMRISC16_INSN_ADDARI16, "addari16", "add", 32,
    { 0|A(NOT_IN_DELAY_SLOT), { (1<<MACH_BASE) } }
  },
/* sub $An1,$imm16 */
  {
    CALMRISC16_INSN_SUBARI16, "subari16", "sub", 32,
    { 0|A(NOT_IN_DELAY_SLOT), { (1<<MACH_BASE) } }
  },
/* com $Rn1 */
  {
    CALMRISC16_INSN_COM, "com", "com", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* com2 $Rn1 */
  {
    CALMRISC16_INSN_COM2, "com2", "com2", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* comc $Rn1 */
  {
    CALMRISC16_INSN_COMC, "comc", "comc", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* decc $Rn1 */
  {
    CALMRISC16_INSN_DECC, "decc", "decc", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* incc $Rn1 */
  {
    CALMRISC16_INSN_INCC, "incc", "incc", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* dt $Rn1 */
  {
    CALMRISC16_INSN_DT, "dt", "dt", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* ext $Rn1 */
  {
    CALMRISC16_INSN_EXT, "ext", "ext", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* rr $Rn1 */
  {
    CALMRISC16_INSN_RR, "rr", "rr", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* sr $Rn1 */
  {
    CALMRISC16_INSN_SR, "sr", "sr", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* sra $Rn1 */
  {
    CALMRISC16_INSN_SRA, "sra", "sra", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* srb $Rn1 */
  {
    CALMRISC16_INSN_SRB, "srb", "srb", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* slb $Rn1 */
  {
    CALMRISC16_INSN_SLB, "slb", "slb", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* rrc $Rn1 */
  {
    CALMRISC16_INSN_RRC, "rrc", "rrc", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* rl $Rn1 */
  {
    CALMRISC16_INSN_RL, "rl", "rl", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* and $Rn,$Ri */
  {
    CALMRISC16_INSN_ANDGRGR, "andgrgr", "and", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* or $Rn,$Ri */
  {
    CALMRISC16_INSN_ORGRGR, "orgrgr", "or", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* xor $Rn,$Ri */
  {
    CALMRISC16_INSN_XORGRGR, "xorgrgr", "xor", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* tst $Rn,$Ri */
  {
    CALMRISC16_INSN_TSTGRGR, "tstgrgr", "tst", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* and r0,$imm8 */
  {
    CALMRISC16_INSN_ANDGRI8, "andgri8", "and", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* or r0,$imm8 */
  {
    CALMRISC16_INSN_ORGRI8, "orgri8", "or", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* xor r0,$imm8 */
  {
    CALMRISC16_INSN_XORGRI8, "xorgri8", "xor", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* tst r0,$imm8 */
  {
    CALMRISC16_INSN_TSTGRI8, "tstgri8", "tst", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* and $Rn1,$eimm16 */
  {
    CALMRISC16_INSN_ANDGRI16, "andgri16", "and", 32,
    { 0|A(NOT_IN_DELAY_SLOT), { (1<<MACH_BASE) } }
  },
/* or $Rn1,$eimm16 */
  {
    CALMRISC16_INSN_ORGRI16, "orgri16", "or", 32,
    { 0|A(NOT_IN_DELAY_SLOT), { (1<<MACH_BASE) } }
  },
/* xor $Rn1,$eimm16 */
  {
    CALMRISC16_INSN_XORGRI16, "xorgri16", "xor", 32,
    { 0|A(NOT_IN_DELAY_SLOT), { (1<<MACH_BASE) } }
  },
/* tst $Rn1,$eimm16 */
  {
    CALMRISC16_INSN_TSTGRI16, "tstgri16", "tst", 32,
    { 0|A(NOT_IN_DELAY_SLOT), { (1<<MACH_BASE) } }
  },
/* ldw $Rn,@[$Ai1+$Rj] */
  {
    CALMRISC16_INSN_LDWARJ, "ldwaRj", "ldw", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* ldw $An,@[$Ai1+$Rj] */
  {
    CALMRISC16_INSN_LDAARJ, "ldaaRj", "ldw", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* ldw $Rn,@[$Ai1+$edisp5] */
  {
    CALMRISC16_INSN_LDWAEDISP5, "ldwaedisp5", "ldw", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* ldw $An,@[$Ai1+$edisp5] */
  {
    CALMRISC16_INSN_LDAAEDISP5, "ldaaedisp5", "ldw", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* ldw $Rn,@[$sp+$edisp9] */
  {
    CALMRISC16_INSN_LDWSPEDISP9, "ldwspedisp9", "ldw", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* ldw $Rn,@[$Ai+$disp16] */
  {
    CALMRISC16_INSN_LDW_GR_A_DISP16, "ldw-gr-a-disp16", "ldw", 32,
    { 0|A(NOT_IN_DELAY_SLOT), { (1<<MACH_BASE) } }
  },
/* ldw $An,@[$Ai+$disp16] */
  {
    CALMRISC16_INSN_LDW_AR_A_DISP16, "ldw-ar-a-disp16", "ldw", 32,
    { 0|A(NOT_IN_DELAY_SLOT), { (1<<MACH_BASE) } }
  },
/* ldb $Dn,@[$Ai1+$Rj] */
  {
    CALMRISC16_INSN_LDBARJ, "ldbaRj", "ldb", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* ldb $Dn,@[$Ai1+$disp4] */
  {
    CALMRISC16_INSN_LDBADISP4, "ldbadisp4", "ldb", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* ldb r0,@[a8+$disp8] */
  {
    CALMRISC16_INSN_LDBA8DISP8, "ldba8disp8", "ldb", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* ldb $Dn,@[$Ai+$disp16] */
  {
    CALMRISC16_INSN_LDBADISP16, "ldbadisp16", "ldb", 32,
    { 0|A(NOT_IN_DELAY_SLOT), { (1<<MACH_BASE) } }
  },
/* ld $En,$Di */
  {
    CALMRISC16_INSN_LDENDI, "ldEnDi", "ld", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* ld $Dn,$Ei */
  {
    CALMRISC16_INSN_LDDNEI, "ldDnEi", "ld", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* ld $Rn,$Ri */
  {
    CALMRISC16_INSN_LDRNRI, "ldRnRi", "ld", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* ld $An,$Ai */
  {
    CALMRISC16_INSN_LDANAI, "ldAnAi", "ld", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* ld $An1,pc */
  {
    CALMRISC16_INSN_LDANPC, "ldAnpc", "ld", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* ld r0,$Rs */
  {
    CALMRISC16_INSN_LDR0SRX, "ldr0srx", "ld", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* ld $Rs,r0 */
  {
    CALMRISC16_INSN_LDSRXR0, "ldsrxr0", "ld", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* ld sr,r0 */
  {
    CALMRISC16_INSN_LDSRR0, "ldsrr0", "ld", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* ld r0,sr */
  {
    CALMRISC16_INSN_LDR0SR, "ldr0sr", "ld", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* ld $Rn,$imm8 */
  {
    CALMRISC16_INSN_LDI8, "ldi8", "ld", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* ld $Rn1,$eimm16 */
  {
    CALMRISC16_INSN_LDI16, "ldi16", "ld", 32,
    { 0|A(NOT_IN_DELAY_SLOT), { (1<<MACH_BASE) } }
  },
/* ld $An,$eimm22 */
  {
    CALMRISC16_INSN_LDA22, "lda22", "ld", 32,
    { 0|A(NOT_IN_DELAY_SLOT), { (1<<MACH_BASE) } }
  },
/* pop $Rlist */
  {
    CALMRISC16_INSN_POPGR, "popgr", "pop", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* pop $Alist */
  {
    CALMRISC16_INSN_POPAR, "popar", "pop", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* ldc $Rn,@$Ai */
  {
    CALMRISC16_INSN_LDC, "ldc", "ldc", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* ldw @[$An2+$Rj],$Ri1 */
  {
    CALMRISC16_INSN_STWARJ, "stwaRj", "ldw", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* ldw @[$Ai1+$Rj],$An */
  {
    CALMRISC16_INSN_STAARJ, "staaRj", "ldw", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* ldw @[$An2+$edisp5],$Ri1 */
  {
    CALMRISC16_INSN_STWAEDISP5, "stwaedisp5", "ldw", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* ldw @[$Ai1+$edisp5],$An */
  {
    CALMRISC16_INSN_STAAEDISP5, "staaedisp5", "ldw", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* ldw @[$sp+$edisp9],$Ri1 */
  {
    CALMRISC16_INSN_STWSPEDISP9, "stwspedisp9", "ldw", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* ldw @[$An1+$disp16],$Ri1 */
  {
    CALMRISC16_INSN_STWADISP16, "stwadisp16", "ldw", 32,
    { 0|A(NOT_IN_DELAY_SLOT), { (1<<MACH_BASE) } }
  },
/* ldw @[$Ai+$disp16],$An */
  {
    CALMRISC16_INSN_STW_AR_A_DISP16, "stw-ar-a-disp16", "ldw", 32,
    { 0|A(NOT_IN_DELAY_SLOT), { (1<<MACH_BASE) } }
  },
/* ldb @[$An2+$Rm],$Di */
  {
    CALMRISC16_INSN_STBARM, "stbaRm", "ldb", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* ldb @[$An2+$disp4],$Di */
  {
    CALMRISC16_INSN_STBADISP4, "stbadisp4", "ldb", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* ldb @[a8+$disp8],r0 */
  {
    CALMRISC16_INSN_STBA8DISP8, "stba8disp8", "ldb", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* ldb @[$An1+$disp16],$Di */
  {
    CALMRISC16_INSN_STBADISP16, "stbadisp16", "ldb", 32,
    { 0|A(NOT_IN_DELAY_SLOT), { (1<<MACH_BASE) } }
  },
/* push $Rlist */
  {
    CALMRISC16_INSN_PUSHGR, "pushgr", "push", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* push $Alist */
  {
    CALMRISC16_INSN_PUSHAR, "pushar", "push", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* bitr @[a8+r1],$bs3 */
  {
    CALMRISC16_INSN_BITR, "bitr", "bitr", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* bits @[a8+r1],$bs3 */
  {
    CALMRISC16_INSN_BITS, "bits", "bits", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* bitc @[a8+r1],$bs3 */
  {
    CALMRISC16_INSN_BITC, "bitc", "bitc", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* bitt @[a8+r1],$bs3 */
  {
    CALMRISC16_INSN_BITT, "bitt", "bitt", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* cmp ge,$Rn,$Ri */
  {
    CALMRISC16_INSN_CMPGEGR, "cmpgegr", "cmp", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* cmp gt,$Rn,$Ri */
  {
    CALMRISC16_INSN_CMPGTGR, "cmpgtgr", "cmp", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* cmp uge,$Rn,$Ri */
  {
    CALMRISC16_INSN_CMPUGEGR, "cmpugegr", "cmp", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* cmp ugt,$Rn,$Ri */
  {
    CALMRISC16_INSN_CMPUGTGR, "cmpugtgr", "cmp", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* cmp eq,$Rn,$Ri */
  {
    CALMRISC16_INSN_CMPEQGR, "cmpeqgr", "cmp", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* cmp ge,$Dn,$imm6 */
  {
    CALMRISC16_INSN_CMPGEGRIMM6, "cmpgegrimm6", "cmp", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* cmp eq,$Dn,$imm8 */
  {
    CALMRISC16_INSN_CMPEQGRIMM8, "cmpeqgrimm8", "cmp", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* cmp ge,$Rn1,$eimm16 */
  {
    CALMRISC16_INSN_CMPGEI16, "cmpgei16", "cmp", 32,
    { 0|A(NOT_IN_DELAY_SLOT), { (1<<MACH_BASE) } }
  },
/* cmp gt,$Rn1,$eimm16 */
  {
    CALMRISC16_INSN_CMPGTI16, "cmpgti16", "cmp", 32,
    { 0|A(NOT_IN_DELAY_SLOT), { (1<<MACH_BASE) } }
  },
/* cmp uge,$Rn1,$eimm16 */
  {
    CALMRISC16_INSN_CMPUGEI16, "cmpugei16", "cmp", 32,
    { 0|A(NOT_IN_DELAY_SLOT), { (1<<MACH_BASE) } }
  },
/* cmp ugt,$Rn1,$eimm16 */
  {
    CALMRISC16_INSN_CMPUGTI16, "cmpugti16", "cmp", 32,
    { 0|A(NOT_IN_DELAY_SLOT), { (1<<MACH_BASE) } }
  },
/* cmp eq,$Rn1,$eimm16 */
  {
    CALMRISC16_INSN_CMPEQI16, "cmpeqi16", "cmp", 32,
    { 0|A(NOT_IN_DELAY_SLOT), { (1<<MACH_BASE) } }
  },
/* cmp eq,$An,$Ai */
  {
    CALMRISC16_INSN_CMPEQARAR, "cmpeqarar", "cmp", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* cmp eq,$An,$eimm22 */
  {
    CALMRISC16_INSN_CMPEQA22, "cmpeqa22", "cmp", 32,
    { 0|A(NOT_IN_DELAY_SLOT), { (1<<MACH_BASE) } }
  },
/* bra $ec2,$elabel8 */
  {
    CALMRISC16_INSN_BRAEXT, "braext", "bra", 16,
    { 0|A(NOT_IN_DELAY_SLOT), { (1<<MACH_BASE) } }
  },
/* brad $ec2,$elabel8 */
  {
    CALMRISC16_INSN_BRADEXT, "bradext", "brad", 16,
    { 0|A(NOT_IN_DELAY_SLOT), { (1<<MACH_BASE) } }
  },
/* bra $elabel11 */
  {
    CALMRISC16_INSN_BRA, "bra", "bra", 16,
    { 0|A(NOT_IN_DELAY_SLOT)|A(UNCOND_CTI), { (1<<MACH_BASE) } }
  },
/* brad $elabel11 */
  {
    CALMRISC16_INSN_BRAD, "brad", "brad", 16,
    { 0|A(NOT_IN_DELAY_SLOT)|A(UNCOND_CTI)|A(DELAY_SLOT), { (1<<MACH_BASE) } }
  },
/* brt $elabel11 */
  {
    CALMRISC16_INSN_BRT, "brt", "brt", 16,
    { 0|A(NOT_IN_DELAY_SLOT)|A(COND_CTI), { (1<<MACH_BASE) } }
  },
/* brtd $elabel11 */
  {
    CALMRISC16_INSN_BRTD, "brtd", "brtd", 16,
    { 0|A(NOT_IN_DELAY_SLOT)|A(COND_CTI)|A(DELAY_SLOT), { (1<<MACH_BASE) } }
  },
/* brf $elabel11 */
  {
    CALMRISC16_INSN_BRF, "brf", "brf", 16,
    { 0|A(NOT_IN_DELAY_SLOT)|A(COND_CTI), { (1<<MACH_BASE) } }
  },
/* brfd $elabel11 */
  {
    CALMRISC16_INSN_BRFD, "brfd", "brfd", 16,
    { 0|A(NOT_IN_DELAY_SLOT)|A(COND_CTI)|A(DELAY_SLOT), { (1<<MACH_BASE) } }
  },
/* bnzd $H,$elabel8 */
  {
    CALMRISC16_INSN_BNZD, "bnzd", "bnzd", 16,
    { 0|A(NOT_IN_DELAY_SLOT)|A(COND_CTI)|A(DELAY_SLOT), { (1<<MACH_BASE) } }
  },
/* jpf $Ai */
  {
    CALMRISC16_INSN_JPFAI, "jpfAi", "jpf", 16,
    { 0|A(NOT_IN_DELAY_SLOT)|A(COND_CTI), { (1<<MACH_BASE) } }
  },
/* jpf $imm22 */
  {
    CALMRISC16_INSN_JPFIMM22, "jpfimm22", "jpf", 32,
    { 0|A(NOT_IN_DELAY_SLOT)|A(COND_CTI), { (1<<MACH_BASE) } }
  },
/* jpt $Ai */
  {
    CALMRISC16_INSN_JPTAI, "jptAi", "jpt", 16,
    { 0|A(NOT_IN_DELAY_SLOT)|A(COND_CTI), { (1<<MACH_BASE) } }
  },
/* jpt $imm22 */
  {
    CALMRISC16_INSN_JPTIMM22, "jptimm22", "jpt", 32,
    { 0|A(NOT_IN_DELAY_SLOT)|A(COND_CTI), { (1<<MACH_BASE) } }
  },
/* jmp $Ai */
  {
    CALMRISC16_INSN_JMPAI, "jmpAi", "jmp", 16,
    { 0|A(NOT_IN_DELAY_SLOT)|A(UNCOND_CTI), { (1<<MACH_BASE) } }
  },
/* jmp $imm22 */
  {
    CALMRISC16_INSN_JMPIMM22, "jmpimm22", "jmp", 32,
    { 0|A(NOT_IN_DELAY_SLOT)|A(UNCOND_CTI), { (1<<MACH_BASE) } }
  },
/* jsr $Ai */
  {
    CALMRISC16_INSN_JSRAI, "jsrAi", "jsr", 16,
    { 0|A(NOT_IN_DELAY_SLOT)|A(UNCOND_CTI), { (1<<MACH_BASE) } }
  },
/* jsr $imm22 */
  {
    CALMRISC16_INSN_JSRIMM22, "jsrimm22", "jsr", 32,
    { 0|A(NOT_IN_DELAY_SLOT)|A(UNCOND_CTI), { (1<<MACH_BASE) } }
  },
/* bsrd $elabel13 */
  {
    CALMRISC16_INSN_BSRD, "bsrd", "bsrd", 16,
    { 0|A(NOT_IN_DELAY_SLOT)|A(UNCOND_CTI)|A(DELAY_SLOT), { (1<<MACH_BASE) } }
  },
/* retd */
  {
    CALMRISC16_INSN_RETD, "retd", "retd", 16,
    { 0|A(NOT_IN_DELAY_SLOT)|A(UNCOND_CTI)|A(DELAY_SLOT), { (1<<MACH_BASE) } }
  },
/* swi $imm6 */
  {
    CALMRISC16_INSN_SWI, "swi", "swi", 16,
    { 0|A(NOT_IN_DELAY_SLOT)|A(UNCOND_CTI), { (1<<MACH_BASE) } }
  },
/* ret_fiq */
  {
    CALMRISC16_INSN_RETFIQ, "retfiq", "ret_fiq", 16,
    { 0|A(NOT_IN_DELAY_SLOT)|A(UNCOND_CTI), { (1<<MACH_BASE) } }
  },
/* ret_irq */
  {
    CALMRISC16_INSN_RETIRQ, "retirq", "ret_irq", 16,
    { 0|A(NOT_IN_DELAY_SLOT)|A(UNCOND_CTI), { (1<<MACH_BASE) } }
  },
/* ret_swi */
  {
    CALMRISC16_INSN_RET_SWI, "ret-swi", "ret_swi", 16,
    { 0|A(NOT_IN_DELAY_SLOT)|A(UNCOND_CTI), { (1<<MACH_BASE) } }
  },
/* break */
  {
    CALMRISC16_INSN_BREAK, "break", "break", 16,
    { 0|A(NOT_IN_DELAY_SLOT), { (1<<MACH_BASE) } }
  },
/* nop */
  {
    CALMRISC16_INSN_NOP, "nop", "nop", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* cld $Dn1,$imm5c */
  {
    CALMRISC16_INSN_CLDR, "cldr", "cld", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* cld $imm5c,$Di1 */
  {
    CALMRISC16_INSN_CLDW, "cldw", "cld", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* cop $imm13 */
  {
    CALMRISC16_INSN_COP, "cop", "cop", 16,
    { 0, { (1<<MACH_BASE) } }
  },
/* sys $imm5 */
  {
    CALMRISC16_INSN_SYS, "sys", "sys", 16,
    { 0, { (1<<MACH_BASE) } }
  },
};

#undef OP
#undef A

/* Initialize anything needed to be done once, before any cpu_open call.  */

static void
init_tables ()
{
}

/* Subroutine of calmrisc16_cgen_cpu_open to look up a mach via its bfd name.  */

static const CGEN_MACH *
lookup_mach_via_bfd_name (table, name)
     const CGEN_MACH *table;
     const char *name;
{
  while (table->name)
    {
      if (strcmp (name, table->bfd_name) == 0)
	return table;
      ++table;
    }
  abort ();
}

/* Subroutine of calmrisc16_cgen_cpu_open to build the hardware table.  */

static void
build_hw_table (cd)
     CGEN_CPU_TABLE *cd;
{
  int i;
  int machs = cd->machs;
  const CGEN_HW_ENTRY *init = & calmrisc16_cgen_hw_table[0];
  /* MAX_HW is only an upper bound on the number of selected entries.
     However each entry is indexed by it's enum so there can be holes in
     the table.  */
  const CGEN_HW_ENTRY **selected =
    (const CGEN_HW_ENTRY **) xmalloc (MAX_HW * sizeof (CGEN_HW_ENTRY *));

  cd->hw_table.init_entries = init;
  cd->hw_table.entry_size = sizeof (CGEN_HW_ENTRY);
  memset (selected, 0, MAX_HW * sizeof (CGEN_HW_ENTRY *));
  /* ??? For now we just use machs to determine which ones we want.  */
  for (i = 0; init[i].name != NULL; ++i)
    if (CGEN_HW_ATTR_VALUE (&init[i], CGEN_HW_MACH)
	& machs)
      selected[init[i].type] = &init[i];
  cd->hw_table.entries = selected;
  cd->hw_table.num_entries = MAX_HW;
}

/* Subroutine of calmrisc16_cgen_cpu_open to build the hardware table.  */

static void
build_ifield_table (cd)
     CGEN_CPU_TABLE *cd;
{
  cd->ifld_table = & calmrisc16_cgen_ifld_table[0];
}

/* Subroutine of calmrisc16_cgen_cpu_open to build the hardware table.  */

static void
build_operand_table (cd)
     CGEN_CPU_TABLE *cd;
{
  int i;
  int machs = cd->machs;
  const CGEN_OPERAND *init = & calmrisc16_cgen_operand_table[0];
  /* MAX_OPERANDS is only an upper bound on the number of selected entries.
     However each entry is indexed by it's enum so there can be holes in
     the table.  */
  const CGEN_OPERAND **selected =
    (const CGEN_OPERAND **) xmalloc (MAX_OPERANDS * sizeof (CGEN_OPERAND *));

  cd->operand_table.init_entries = init;
  cd->operand_table.entry_size = sizeof (CGEN_OPERAND);
  memset (selected, 0, MAX_OPERANDS * sizeof (CGEN_OPERAND *));
  /* ??? For now we just use mach to determine which ones we want.  */
  for (i = 0; init[i].name != NULL; ++i)
    if (CGEN_OPERAND_ATTR_VALUE (&init[i], CGEN_OPERAND_MACH)
	& machs)
      selected[init[i].type] = &init[i];
  cd->operand_table.entries = selected;
  cd->operand_table.num_entries = MAX_OPERANDS;
}

/* Subroutine of calmrisc16_cgen_cpu_open to build the hardware table.
   ??? This could leave out insns not supported by the specified mach/isa,
   but that would cause errors like "foo only supported by bar" to become
   "unknown insn", so for now we include all insns and require the app to
   do the checking later.
   ??? On the other hand, parsing of such insns may require their hardware or
   operand elements to be in the table [which they mightn't be].  */

static void
build_insn_table (cd)
     CGEN_CPU_TABLE *cd;
{
  int i;
  const CGEN_IBASE *ib = & calmrisc16_cgen_insn_table[0];
  CGEN_INSN *insns = (CGEN_INSN *) xmalloc (MAX_INSNS * sizeof (CGEN_INSN));

  memset (insns, 0, MAX_INSNS * sizeof (CGEN_INSN));
  for (i = 0; i < MAX_INSNS; ++i)
    insns[i].base = &ib[i];
  cd->insn_table.init_entries = insns;
  cd->insn_table.entry_size = sizeof (CGEN_IBASE);
  cd->insn_table.num_init_entries = MAX_INSNS;
}

/* Subroutine of calmrisc16_cgen_cpu_open to rebuild the tables.  */

static void
calmrisc16_cgen_rebuild_tables (cd)
     CGEN_CPU_TABLE *cd;
{
  int i,n_isas;
  unsigned int isas = cd->isas;
#if 0
  unsigned int machs = cd->machs;
#endif

  cd->int_insn_p = CGEN_INT_INSN_P;

  /* Data derived from the isa spec.  */
#define UNSET (CGEN_SIZE_UNKNOWN + 1)
  cd->default_insn_bitsize = UNSET;
  cd->base_insn_bitsize = UNSET;
  cd->min_insn_bitsize = 65535; /* some ridiculously big number */
  cd->max_insn_bitsize = 0;
  for (i = 0; i < MAX_ISAS; ++i)
    if (((1 << i) & isas) != 0)
      {
	const CGEN_ISA *isa = & calmrisc16_cgen_isa_table[i];

	/* Default insn sizes of all selected isas must be equal or we set
	   the result to 0, meaning "unknown".  */
	if (cd->default_insn_bitsize == UNSET)
	  cd->default_insn_bitsize = isa->default_insn_bitsize;
	else if (isa->default_insn_bitsize == cd->default_insn_bitsize)
	  ; /* this is ok */
	else
	  cd->default_insn_bitsize = CGEN_SIZE_UNKNOWN;

	/* Base insn sizes of all selected isas must be equal or we set
	   the result to 0, meaning "unknown".  */
	if (cd->base_insn_bitsize == UNSET)
	  cd->base_insn_bitsize = isa->base_insn_bitsize;
	else if (isa->base_insn_bitsize == cd->base_insn_bitsize)
	  ; /* this is ok */
	else
	  cd->base_insn_bitsize = CGEN_SIZE_UNKNOWN;

	/* Set min,max insn sizes.  */
	if (isa->min_insn_bitsize < cd->min_insn_bitsize)
	  cd->min_insn_bitsize = isa->min_insn_bitsize;
	if (isa->max_insn_bitsize > cd->max_insn_bitsize)
	  cd->max_insn_bitsize = isa->max_insn_bitsize;

	++n_isas;
      }

#if 0 /* Does nothing?? */
  /* Data derived from the mach spec.  */
  for (i = 0; i < MAX_MACHS; ++i)
    if (((1 << i) & machs) != 0)
      {
	const CGEN_MACH *mach = & calmrisc16_cgen_mach_table[i];

	++n_machs;
      }
#endif

  /* Determine which hw elements are used by MACH.  */
  build_hw_table (cd);

  /* Build the ifield table.  */
  build_ifield_table (cd);

  /* Determine which operands are used by MACH/ISA.  */
  build_operand_table (cd);

  /* Build the instruction table.  */
  build_insn_table (cd);
}

/* Initialize a cpu table and return a descriptor.
   It's much like opening a file, and must be the first function called.
   The arguments are a set of (type/value) pairs, terminated with
   CGEN_CPU_OPEN_END.

   Currently supported values:
   CGEN_CPU_OPEN_ISAS:    bitmap of values in enum isa_attr
   CGEN_CPU_OPEN_MACHS:   bitmap of values in enum mach_attr
   CGEN_CPU_OPEN_BFDMACH: specify 1 mach using bfd name
   CGEN_CPU_OPEN_ENDIAN:  specify endian choice
   CGEN_CPU_OPEN_END:     terminates arguments

   ??? Simultaneous multiple isas might not make sense, but it's not (yet)
   precluded.

   ??? We only support ISO C stdargs here, not K&R.
   Laziness, plus experiment to see if anything requires K&R - eventually
   K&R will no longer be supported - e.g. GDB is currently trying this.  */

CGEN_CPU_DESC
calmrisc16_cgen_cpu_open (enum cgen_cpu_open_arg arg_type, ...)
{
  CGEN_CPU_TABLE *cd = (CGEN_CPU_TABLE *) xmalloc (sizeof (CGEN_CPU_TABLE));
  static int init_p;
  unsigned int isas = 0;  /* 0 = "unspecified" */
  unsigned int machs = 0; /* 0 = "unspecified" */
  enum cgen_endian endian = CGEN_ENDIAN_UNKNOWN;
  va_list ap;

  if (! init_p)
    {
      init_tables ();
      init_p = 1;
    }

  memset (cd, 0, sizeof (*cd));

  va_start (ap, arg_type);
  while (arg_type != CGEN_CPU_OPEN_END)
    {
      switch (arg_type)
	{
	case CGEN_CPU_OPEN_ISAS :
	  isas = va_arg (ap, unsigned int);
	  break;
	case CGEN_CPU_OPEN_MACHS :
	  machs = va_arg (ap, unsigned int);
	  break;
	case CGEN_CPU_OPEN_BFDMACH :
	  {
	    const char *name = va_arg (ap, const char *);
	    const CGEN_MACH *mach =
	      lookup_mach_via_bfd_name (calmrisc16_cgen_mach_table, name);

	    machs |= mach->num << 1;
	    break;
	  }
	case CGEN_CPU_OPEN_ENDIAN :
	  endian = va_arg (ap, enum cgen_endian);
	  break;
	default :
	  fprintf (stderr, "calmrisc16_cgen_cpu_open: unsupported argument `%d'\n",
		   arg_type);
	  abort (); /* ??? return NULL? */
	}
      arg_type = va_arg (ap, enum cgen_cpu_open_arg);
    }
  va_end (ap);

  /* mach unspecified means "all" */
  if (machs == 0)
    machs = (1 << MAX_MACHS) - 1;
  /* base mach is always selected */
  machs |= 1;
  /* isa unspecified means "all" */
  if (isas == 0)
    isas = (1 << MAX_ISAS) - 1;
  if (endian == CGEN_ENDIAN_UNKNOWN)
    {
      /* ??? If target has only one, could have a default.  */
      fprintf (stderr, "calmrisc16_cgen_cpu_open: no endianness specified\n");
      abort ();
    }

  cd->isas = isas;
  cd->machs = machs;
  cd->endian = endian;
  /* FIXME: for the sparc case we can determine insn-endianness statically.
     The worry here is where both data and insn endian can be independently
     chosen, in which case this function will need another argument.
     Actually, will want to allow for more arguments in the future anyway.  */
  cd->insn_endian = endian;

  /* Table (re)builder.  */
  cd->rebuild_tables = calmrisc16_cgen_rebuild_tables;
  calmrisc16_cgen_rebuild_tables (cd);

  /* Default to not allowing signed overflow.  */
  cd->signed_overflow_ok_p = 0;
  
  return (CGEN_CPU_DESC) cd;
}

/* Cover fn to calmrisc16_cgen_cpu_open to handle the simple case of 1 isa, 1 mach.
   MACH_NAME is the bfd name of the mach.  */

CGEN_CPU_DESC
calmrisc16_cgen_cpu_open_1 (mach_name, endian)
     const char *mach_name;
     enum cgen_endian endian;
{
  return calmrisc16_cgen_cpu_open (CGEN_CPU_OPEN_BFDMACH, mach_name,
			       CGEN_CPU_OPEN_ENDIAN, endian,
			       CGEN_CPU_OPEN_END);
}

/* Close a cpu table.
   ??? This can live in a machine independent file, but there's currently
   no place to put this file (there's no libcgen).  libopcodes is the wrong
   place as some simulator ports use this but they don't use libopcodes.  */

void
calmrisc16_cgen_cpu_close (cd)
     CGEN_CPU_DESC cd;
{
  if (cd->insn_table.init_entries)
    free ((CGEN_INSN *) cd->insn_table.init_entries);
  if (cd->hw_table.entries)
    free ((CGEN_HW_ENTRY *) cd->hw_table.entries);
  free (cd);
}

