/* CPU data header for calmrisc16.

THIS FILE IS MACHINE GENERATED WITH CGEN.

Copyright (C) 1996, 1997, 1998, 1999, 2000 Free Software Foundation, Inc.

This file is part of the GNU Binutils and/or GDB, the GNU debugger.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

*/

#ifndef CALMRISC16_CPU_H
#define CALMRISC16_CPU_H

#define CGEN_ARCH calmrisc16

/* Given symbol S, return calmrisc16_cgen_<S>.  */
#if defined (__STDC__) || defined (ALMOST_STDC) || defined (HAVE_STRINGIZE)
#define CGEN_SYM(s) calmrisc16##_cgen_##s
#else
#define CGEN_SYM(s) calmrisc16/**/_cgen_/**/s
#endif


/* Selected cpu families.  */
#define HAVE_CPU_CALMRISC16BF

#define CGEN_INSN_LSB0_P 0

/* Minimum size of any insn (in bytes).  */
#define CGEN_MIN_INSN_SIZE 2

/* Maximum size of any insn (in bytes).  */
#define CGEN_MAX_INSN_SIZE 4

#define CGEN_INT_INSN_P 1

/* Maximum nymber of syntax bytes in an instruction.  */
#define CGEN_ACTUAL_MAX_SYNTAX_BYTES 17

/* CGEN_MNEMONIC_OPERANDS is defined if mnemonics have operands.
   e.g. In "b,a foo" the ",a" is an operand.  If mnemonics have operands
   we can't hash on everything up to the space.  */
#define CGEN_MNEMONIC_OPERANDS

/* Maximum number of fields in an instruction.  */
#define CGEN_ACTUAL_MAX_IFMT_OPERANDS 7

/* Enums.  */

/* Enum declaration for insn op enums.  */
typedef enum insn_op1 {
  OP1_0, OP1_1, OP1_2, OP1_3
 , OP1_4, OP1_5, OP1_6, OP1_7
 , OP1_8, OP1_9, OP1_A, OP1_B
 , OP1_C, OP1_D, OP1_E, OP1_F
} INSN_OP1;

/* Enum declaration for insn op enums.  */
typedef enum insn_op2 {
  OP2_0, OP2_1, OP2_2, OP2_3
 , OP2_4, OP2_5, OP2_6, OP2_7
 , OP2_8, OP2_9, OP2_A, OP2_B
 , OP2_C, OP2_D, OP2_E, OP2_F
} INSN_OP2;

/* Enum declaration for insn op enums.  */
typedef enum insn_op3 {
  OP3_0, OP3_1, OP3_2, OP3_3
 , OP3_4, OP3_5, OP3_6, OP3_7
 , OP3_8, OP3_9, OP3_A, OP3_B
 , OP3_C, OP3_D, OP3_E, OP3_F
} INSN_OP3;

/* Enum declaration for insn op enums.  */
typedef enum insn_op4 {
  OP4_0, OP4_1, OP4_2, OP4_3
 , OP4_4, OP4_5, OP4_6, OP4_7
 , OP4_8, OP4_9, OP4_A, OP4_B
 , OP4_C, OP4_D, OP4_E, OP4_F
} INSN_OP4;

/* Enum declaration for insn op enums.  */
typedef enum insn_op0_3 {
  OP0_3_0, OP0_3_1, OP0_3_2, OP0_3_3
 , OP0_3_4, OP0_3_5, OP0_3_6, OP0_3_7
} INSN_OP0_3;

/* Enum declaration for insn op enums.  */
typedef enum insn_op4_1 {
  OP4_1_0, OP4_1_1
} INSN_OP4_1;

/* Enum declaration for insn op enums.  */
typedef enum insn_op4_3 {
  OP4_3_0, OP4_3_1, OP4_3_2, OP4_3_3
 , OP4_3_4, OP4_3_5, OP4_3_6, OP4_3_7
} INSN_OP4_3;

/* Enum declaration for insn op enums.  */
typedef enum insn_op8_1 {
  OP8_1_0, OP8_1_1
} INSN_OP8_1;

/* Enum declaration for insn op enums.  */
typedef enum insn_op8_2 {
  OP8_2_0, OP8_2_1, OP8_2_2, OP8_2_3
} INSN_OP8_2;

/* Enum declaration for insn op enums.  */
typedef enum insn_op8_3 {
  OP8_3_0, OP8_3_1, OP8_3_2, OP8_3_3
 , OP8_3_4, OP8_3_5, OP8_3_6, OP8_3_7
} INSN_OP8_3;

/* Enum declaration for insn op enums.  */
typedef enum insn_op9_1 {
  OP9_1_0, OP9_1_1
} INSN_OP9_1;

/* Enum declaration for insn op enums.  */
typedef enum insn_op12_1 {
  OP12_1_0, OP12_1_1
} INSN_OP12_1;

/* Enum declaration for comparison mode enums.  */
typedef enum insn_cmode1 {
  CMODE1_GE, CMODE1_GT, CMODE1_UGE, CMODE1_UGT
 , CMODE1_EQ
} INSN_CMODE1;

/* Enum declaration for comparison mode enums.  */
typedef enum insn_cmode2 {
  CMODE2_GE, CMODE2_GT, CMODE2_UGE, CMODE2_UGT
 , CMODE2_EQ
} INSN_CMODE2;

/* Enum declaration for branch mode enums.  */
typedef enum insn_bmode {
  BR_RESERVED, BR_A, BR_F, BR_T
} INSN_BMODE;

/* Enum declaration for delay indicator enums.  */
typedef enum insn_d {
  D_0, D_1
} INSN_D;

/* Enum declaration for SR bit number enum.  */
typedef enum insn_bs3 {
  BS3_FE, BS3_IE, BS3_TE, BS3_V
 , BS3_Z0, BS3_Z1, BS3_PM
} INSN_BS3;

/* Enum declaration for .  */
typedef enum gr_names {
  H_GR_R0, H_GR_R1, H_GR_R2, H_GR_R3
 , H_GR_R4, H_GR_R5, H_GR_R6, H_GR_R7
 , H_GR_R8, H_GR_R9, H_GR_R10, H_GR_R11
 , H_GR_R12, H_GR_R13, H_GR_R14, H_GR_R15
} GR_NAMES;

/* Enum declaration for .  */
typedef enum er_names {
  H_ER_E8 = 8, H_ER_E9 = 9, H_ER_E10 = 10, H_ER_E11 = 11
 , H_ER_E12 = 12, H_ER_E13 = 13, H_ER_E14 = 14, H_ER_E15 = 15
} ER_NAMES;

/* Enum declaration for .  */
typedef enum ar_names {
  H_AR_LR = 14, H_AR_SP = 15, H_AR_A8 = 8, H_AR_A9 = 9
 , H_AR_A10 = 10, H_AR_A11 = 11, H_AR_A12 = 12, H_AR_A13 = 13
 , H_AR_A14 = 14, H_AR_A15 = 15
} AR_NAMES;

/* Enum declaration for .  */
typedef enum spr_names {
  H_SPR_SPCL_FIQ = 0, H_SPR_SPCH_FIQ = 1, H_SPR_SSR_FIQ = 2, H_SPR_SPCL_IRQ = 4
 , H_SPR_SPCH_IRQ = 5, H_SPR_SSR_IRQ = 6, H_SPR_SSR_SWI = 10
} SPR_NAMES;

/* Attributes.  */

/* Enum declaration for machine type selection.  */
typedef enum mach_attr {
  MACH_BASE, MACH_CALMRISC16, MACH_MAX
} MACH_ATTR;

/* Enum declaration for instruction set selection.  */
typedef enum isa_attr {
  ISA_CALMRISC16, ISA_MAX
} ISA_ATTR;

/* Number of architecture variants.  */
#define MAX_ISAS  1
#define MAX_MACHS ((int) MACH_MAX)

/* Ifield support.  */

extern const struct cgen_ifld calmrisc16_cgen_ifld_table[];

/* Ifield attribute indices.  */

/* Enum declaration for cgen_ifld attrs.  */
typedef enum cgen_ifld_attr {
  CGEN_IFLD_VIRTUAL, CGEN_IFLD_PCREL_ADDR, CGEN_IFLD_ABS_ADDR, CGEN_IFLD_RESERVED
 , CGEN_IFLD_SIGN_OPT, CGEN_IFLD_SIGNED, CGEN_IFLD_END_BOOLS, CGEN_IFLD_START_NBOOLS = 31
 , CGEN_IFLD_MACH, CGEN_IFLD_END_NBOOLS
} CGEN_IFLD_ATTR;

/* Number of non-boolean elements in cgen_ifld_attr.  */
#define CGEN_IFLD_NBOOL_ATTRS (CGEN_IFLD_END_NBOOLS - CGEN_IFLD_START_NBOOLS - 1)

/* Enum declaration for calmrisc16 ifield types.  */
typedef enum ifield_type {
  CALMRISC16_F_NIL, CALMRISC16_F_ANYOF, CALMRISC16_F_OP1, CALMRISC16_F_OP2
 , CALMRISC16_F_OP3, CALMRISC16_F_OP4, CALMRISC16_F_OP0_3, CALMRISC16_F_OP4_1
 , CALMRISC16_F_OP4_3, CALMRISC16_F_OP8_1, CALMRISC16_F_OP8_2, CALMRISC16_F_OP8_3
 , CALMRISC16_F_OP9_1, CALMRISC16_F_OP12_1, CALMRISC16_F_RN, CALMRISC16_F_RN1
 , CALMRISC16_F_RM, CALMRISC16_F_DN, CALMRISC16_F_DN1, CALMRISC16_F_H
 , CALMRISC16_F_RLIST_RM, CALMRISC16_F_RLIST_RN, CALMRISC16_F_RLIST, CALMRISC16_F_EN
 , CALMRISC16_F_AN, CALMRISC16_F_AN1, CALMRISC16_F_AN2, CALMRISC16_F_ALIST_AM
 , CALMRISC16_F_ALIST_AN, CALMRISC16_F_ALIST, CALMRISC16_F_RS, CALMRISC16_F_IMM5
 , CALMRISC16_F_IMM5C, CALMRISC16_F_IMM6, CALMRISC16_F_IMM7, CALMRISC16_F_IMM8
 , CALMRISC16_F_IMM13, CALMRISC16_F_IMM16, CALMRISC16_F_IMM22, CALMRISC16_F_DISP4
 , CALMRISC16_F_DISP8, CALMRISC16_F_EOFFSET8, CALMRISC16_F_EOFFSET11, CALMRISC16_F_EOFFSET13
 , CALMRISC16_F_EDISP5, CALMRISC16_F_EDISP9, CALMRISC16_F_DISP16, CALMRISC16_F_CMODE1
 , CALMRISC16_F_CMODE2, CALMRISC16_F_BMODE, CALMRISC16_F_D, CALMRISC16_F_BS3
 , CALMRISC16_F_EC2, CALMRISC16_F_MAX
} IFIELD_TYPE;

#define MAX_IFLD ((int) CALMRISC16_F_MAX)

/* Hardware attribute indices.  */

/* Enum declaration for cgen_hw attrs.  */
typedef enum cgen_hw_attr {
  CGEN_HW_VIRTUAL, CGEN_HW_CACHE_ADDR, CGEN_HW_PC, CGEN_HW_PROFILE
 , CGEN_HW_END_BOOLS, CGEN_HW_START_NBOOLS = 31, CGEN_HW_MACH, CGEN_HW_END_NBOOLS
} CGEN_HW_ATTR;

/* Number of non-boolean elements in cgen_hw_attr.  */
#define CGEN_HW_NBOOL_ATTRS (CGEN_HW_END_NBOOLS - CGEN_HW_START_NBOOLS - 1)

/* Enum declaration for calmrisc16 hardware types.  */
typedef enum cgen_hw_type {
  HW_H_MEMORY, HW_H_SINT, HW_H_UINT, HW_H_ADDR
 , HW_H_IADDR, HW_H_PC, HW_H_GR, HW_H_R0
 , HW_H_R1, HW_H_ER, HW_H_AR, HW_H_A8
 , HW_H_A14, HW_H_A15, HW_H_SPR, HW_H_SPCL_FIQ
 , HW_H_SPCH_FIQ, HW_H_SSR_FIQ, HW_H_SPCL_IRQ, HW_H_SPCH_IRQ
 , HW_H_SSR_IRQ, HW_H_SSR_SWI, HW_H_T, HW_H_Z1
 , HW_H_Z0, HW_H_V, HW_H_PM, HW_H_TE
 , HW_H_IE, HW_H_FE, HW_H_SR, HW_H_EC2
 , HW_MAX
} CGEN_HW_TYPE;

#define MAX_HW ((int) HW_MAX)

/* Operand attribute indices.  */

/* Enum declaration for cgen_operand attrs.  */
typedef enum cgen_operand_attr {
  CGEN_OPERAND_VIRTUAL, CGEN_OPERAND_PCREL_ADDR, CGEN_OPERAND_ABS_ADDR, CGEN_OPERAND_SIGN_OPT
 , CGEN_OPERAND_SIGNED, CGEN_OPERAND_NEGATIVE, CGEN_OPERAND_RELAX, CGEN_OPERAND_SEM_ONLY
 , CGEN_OPERAND_END_BOOLS, CGEN_OPERAND_START_NBOOLS = 31, CGEN_OPERAND_MACH, CGEN_OPERAND_END_NBOOLS
} CGEN_OPERAND_ATTR;

/* Number of non-boolean elements in cgen_operand_attr.  */
#define CGEN_OPERAND_NBOOL_ATTRS (CGEN_OPERAND_END_NBOOLS - CGEN_OPERAND_START_NBOOLS - 1)

/* Enum declaration for calmrisc16 operand types.  */
typedef enum cgen_operand_type {
  CALMRISC16_OPERAND_PC, CALMRISC16_OPERAND_RN, CALMRISC16_OPERAND_RN1, CALMRISC16_OPERAND_RI
 , CALMRISC16_OPERAND_RI1, CALMRISC16_OPERAND_RJ, CALMRISC16_OPERAND_RM, CALMRISC16_OPERAND_DN
 , CALMRISC16_OPERAND_DN1, CALMRISC16_OPERAND_DI, CALMRISC16_OPERAND_DI1, CALMRISC16_OPERAND_H
 , CALMRISC16_OPERAND_RLIST, CALMRISC16_OPERAND_EN, CALMRISC16_OPERAND_EI, CALMRISC16_OPERAND_AN
 , CALMRISC16_OPERAND_AN1, CALMRISC16_OPERAND_AN2, CALMRISC16_OPERAND_AI, CALMRISC16_OPERAND_AI1
 , CALMRISC16_OPERAND_ALIST, CALMRISC16_OPERAND_RS, CALMRISC16_OPERAND_IMM5C, CALMRISC16_OPERAND_IMM22
 , CALMRISC16_OPERAND_EIMM22, CALMRISC16_OPERAND_IMM5, CALMRISC16_OPERAND_IMM6, CALMRISC16_OPERAND_IMM7
 , CALMRISC16_OPERAND_IMM8, CALMRISC16_OPERAND_IMM16, CALMRISC16_OPERAND_EIMM16, CALMRISC16_OPERAND_IMM13
 , CALMRISC16_OPERAND_ELABEL8, CALMRISC16_OPERAND_ELABEL11, CALMRISC16_OPERAND_ELABEL13, CALMRISC16_OPERAND_DISP4
 , CALMRISC16_OPERAND_DISP8, CALMRISC16_OPERAND_EDISP5, CALMRISC16_OPERAND_EDISP9, CALMRISC16_OPERAND_DISP16
 , CALMRISC16_OPERAND_BS3, CALMRISC16_OPERAND_EC2, CALMRISC16_OPERAND_T, CALMRISC16_OPERAND_PM
 , CALMRISC16_OPERAND_Z1, CALMRISC16_OPERAND_Z0, CALMRISC16_OPERAND_V, CALMRISC16_OPERAND_TE
 , CALMRISC16_OPERAND_IE, CALMRISC16_OPERAND_FE, CALMRISC16_OPERAND_SR, CALMRISC16_OPERAND_R0
 , CALMRISC16_OPERAND_R1, CALMRISC16_OPERAND_A8, CALMRISC16_OPERAND_A14, CALMRISC16_OPERAND_SP
 , CALMRISC16_OPERAND_SPCL_FIQ, CALMRISC16_OPERAND_SPCH_FIQ, CALMRISC16_OPERAND_SSR_FIQ, CALMRISC16_OPERAND_SPCL_IRQ
 , CALMRISC16_OPERAND_SPCH_IRQ, CALMRISC16_OPERAND_SSR_IRQ, CALMRISC16_OPERAND_SSR_SWI, CALMRISC16_OPERAND_MAX
} CGEN_OPERAND_TYPE;

/* Number of operands types.  */
#define MAX_OPERANDS 63

/* Maximum number of operands referenced by any insn.  */
#define MAX_OPERAND_INSTANCES 8

/* Insn attribute indices.  */

/* Enum declaration for cgen_insn attrs.  */
typedef enum cgen_insn_attr {
  CGEN_INSN_ALIAS, CGEN_INSN_VIRTUAL, CGEN_INSN_UNCOND_CTI, CGEN_INSN_COND_CTI
 , CGEN_INSN_SKIP_CTI, CGEN_INSN_DELAY_SLOT, CGEN_INSN_RELAXABLE, CGEN_INSN_RELAX
 , CGEN_INSN_NO_DIS, CGEN_INSN_PBB, CGEN_INSN_NOT_IN_DELAY_SLOT, CGEN_INSN_END_BOOLS
 , CGEN_INSN_START_NBOOLS = 31, CGEN_INSN_MACH, CGEN_INSN_END_NBOOLS
} CGEN_INSN_ATTR;

/* Number of non-boolean elements in cgen_insn_attr.  */
#define CGEN_INSN_NBOOL_ATTRS (CGEN_INSN_END_NBOOLS - CGEN_INSN_START_NBOOLS - 1)

/* cgen.h uses things we just defined.  */
#include "opcode/cgen.h"

/* Attributes.  */
extern const CGEN_ATTR_TABLE calmrisc16_cgen_hardware_attr_table[];
extern const CGEN_ATTR_TABLE calmrisc16_cgen_ifield_attr_table[];
extern const CGEN_ATTR_TABLE calmrisc16_cgen_operand_attr_table[];
extern const CGEN_ATTR_TABLE calmrisc16_cgen_insn_attr_table[];

/* Hardware decls.  */

extern CGEN_KEYWORD calmrisc16_cgen_opval_gr_names;
extern CGEN_KEYWORD calmrisc16_cgen_opval_h_r0;
extern CGEN_KEYWORD calmrisc16_cgen_opval_h_r1;
extern CGEN_KEYWORD calmrisc16_cgen_opval_er_names;
extern CGEN_KEYWORD calmrisc16_cgen_opval_ar_names;
extern CGEN_KEYWORD calmrisc16_cgen_opval_h_a8;
extern CGEN_KEYWORD calmrisc16_cgen_opval_h_a14;
extern CGEN_KEYWORD calmrisc16_cgen_opval_h_a15;
extern CGEN_KEYWORD calmrisc16_cgen_opval_spr_names;
extern CGEN_KEYWORD calmrisc16_cgen_opval_h_spcl_fiq;
extern CGEN_KEYWORD calmrisc16_cgen_opval_h_spch_fiq;
extern CGEN_KEYWORD calmrisc16_cgen_opval_h_ssr_fiq;
extern CGEN_KEYWORD calmrisc16_cgen_opval_h_spcl_irq;
extern CGEN_KEYWORD calmrisc16_cgen_opval_h_spch_irq;
extern CGEN_KEYWORD calmrisc16_cgen_opval_h_ssr_irq;
extern CGEN_KEYWORD calmrisc16_cgen_opval_h_ssr_swi;
extern CGEN_KEYWORD calmrisc16_cgen_opval_h_sr;
extern CGEN_KEYWORD calmrisc16_cgen_opval_h_ec2;




#endif /* CALMRISC16_CPU_H */
