# CALMRISC16 startup code

	.section .text
	.global	_start
_start:
	; initialize stack pointer
	ld	sp,#__stack
	
	; Copy initialized data from program space to data space
	ld	a8,__etext
	ld	a9,_fdata
	ld	a10,_edata

	cmp     eq,a10,a9
	brt	.L1
.L0:
	ldc	r5,@a8
	add	a8,#2
	ldw	@[a9+0],r5
	add	a9,#2
	cmp	eq,a10,a9
	brf	.L0
.L1:
	; clear static / global variables
	ld	a8,_edata
	; ??? This should really be:
	; ld r6,#%hi(_end - _edata)
	; ld r7,#%lo(_end - _edata)
	; - but the assembler won't handle that.
	ld	r6,#%hi(_end)
	sub	r6,#%hi(_edata)
	ld	r7,#%lo(_end)
	sub	r7,r8
	jsr	___bzero_evendest

	; call global and static constructors
	jsr	_init		 
	; and have destructors called from exit.
	ld	a10,#_fini
	push	a10
	jsr	_atexit

	; clear argc, argv and envp.
	ld	a10,#0
	ldw	@[a15+2],a10
	push	r10
	push	a10
	jsr	_main
	ldw	@[a15+2],r0
	jmp	_exit

	