/* Instruction opcode header for calmrisc16.

THIS FILE IS MACHINE GENERATED WITH CGEN.

Copyright (C) 1996, 1997, 1998, 1999, 2000 Free Software Foundation, Inc.

This file is part of the GNU Binutils and/or GDB, the GNU debugger.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

*/

#ifndef CALMRISC16_OPC_H
#define CALMRISC16_OPC_H

/* -- opc.h */

/* ??? This can be improved upon.  */
#undef CGEN_DIS_HASH_SIZE
#define CGEN_DIS_HASH_SIZE 16
#undef CGEN_DIS_HASH
#define CGEN_DIS_HASH(buffer, value) (((unsigned char *) (buffer))[0] >> 4)

/* -- */
/* Enum declaration for calmrisc16 instruction types.  */
typedef enum cgen_insn_type {
  CALMRISC16_INSN_INVALID, CALMRISC16_INSN_CLRSRFE, CALMRISC16_INSN_SETSRFE, CALMRISC16_INSN_TSTSRFE
 , CALMRISC16_INSN_CLRSRIE, CALMRISC16_INSN_SETSRIE, CALMRISC16_INSN_TSTSRIE, CALMRISC16_INSN_CLRSRTE
 , CALMRISC16_INSN_SETSRTE, CALMRISC16_INSN_TSTSRTE, CALMRISC16_INSN_CLRSRV, CALMRISC16_INSN_SETSRV
 , CALMRISC16_INSN_TSTSRV, CALMRISC16_INSN_CLRSRZ0, CALMRISC16_INSN_SETSRZ0, CALMRISC16_INSN_TSTSRZ0
 , CALMRISC16_INSN_CLRSRZ1, CALMRISC16_INSN_SETSRZ1, CALMRISC16_INSN_TSTSRZ1, CALMRISC16_INSN_CLRSRPM
 , CALMRISC16_INSN_SETSRPM, CALMRISC16_INSN_TSTSRPM, CALMRISC16_INSN_ADDGRGR, CALMRISC16_INSN_SUBGRGR
 , CALMRISC16_INSN_ADDGRGRC, CALMRISC16_INSN_SUBGRGRC, CALMRISC16_INSN_MULUU, CALMRISC16_INSN_MULUS
 , CALMRISC16_INSN_MULSU, CALMRISC16_INSN_MULSS, CALMRISC16_INSN_ADDGRI7, CALMRISC16_INSN_SUBGRI7
 , CALMRISC16_INSN_ADDGRI16, CALMRISC16_INSN_ADDGRI16C, CALMRISC16_INSN_SUBGRI16C, CALMRISC16_INSN_ADDARGR
 , CALMRISC16_INSN_SUBARGR, CALMRISC16_INSN_ADDARI5, CALMRISC16_INSN_SUBARI5, CALMRISC16_INSN_ADDARI16
 , CALMRISC16_INSN_SUBARI16, CALMRISC16_INSN_COM, CALMRISC16_INSN_COM2, CALMRISC16_INSN_COMC
 , CALMRISC16_INSN_DECC, CALMRISC16_INSN_INCC, CALMRISC16_INSN_DT, CALMRISC16_INSN_EXT
 , CALMRISC16_INSN_RR, CALMRISC16_INSN_SR, CALMRISC16_INSN_SRA, CALMRISC16_INSN_SRB
 , CALMRISC16_INSN_SLB, CALMRISC16_INSN_RRC, CALMRISC16_INSN_RL, CALMRISC16_INSN_ANDGRGR
 , CALMRISC16_INSN_ORGRGR, CALMRISC16_INSN_XORGRGR, CALMRISC16_INSN_TSTGRGR, CALMRISC16_INSN_ANDGRI8
 , CALMRISC16_INSN_ORGRI8, CALMRISC16_INSN_XORGRI8, CALMRISC16_INSN_TSTGRI8, CALMRISC16_INSN_ANDGRI16
 , CALMRISC16_INSN_ORGRI16, CALMRISC16_INSN_XORGRI16, CALMRISC16_INSN_TSTGRI16, CALMRISC16_INSN_LDWARJ
 , CALMRISC16_INSN_LDAARJ, CALMRISC16_INSN_LDWAEDISP5, CALMRISC16_INSN_LDAAEDISP5, CALMRISC16_INSN_LDWSPEDISP9
 , CALMRISC16_INSN_LDW_GR_A_DISP16, CALMRISC16_INSN_LDW_AR_A_DISP16, CALMRISC16_INSN_LDBARJ, CALMRISC16_INSN_LDBADISP4
 , CALMRISC16_INSN_LDBA8DISP8, CALMRISC16_INSN_LDBADISP16, CALMRISC16_INSN_LDENDI, CALMRISC16_INSN_LDDNEI
 , CALMRISC16_INSN_LDRNRI, CALMRISC16_INSN_LDANAI, CALMRISC16_INSN_LDANPC, CALMRISC16_INSN_LDR0SRX
 , CALMRISC16_INSN_LDSRXR0, CALMRISC16_INSN_LDSRR0, CALMRISC16_INSN_LDR0SR, CALMRISC16_INSN_LDI8
 , CALMRISC16_INSN_LDI16, CALMRISC16_INSN_LDA22, CALMRISC16_INSN_POPGR, CALMRISC16_INSN_POPAR
 , CALMRISC16_INSN_LDC, CALMRISC16_INSN_STWARJ, CALMRISC16_INSN_STAARJ, CALMRISC16_INSN_STWAEDISP5
 , CALMRISC16_INSN_STAAEDISP5, CALMRISC16_INSN_STWSPEDISP9, CALMRISC16_INSN_STWADISP16, CALMRISC16_INSN_STW_AR_A_DISP16
 , CALMRISC16_INSN_STBARM, CALMRISC16_INSN_STBADISP4, CALMRISC16_INSN_STBA8DISP8, CALMRISC16_INSN_STBADISP16
 , CALMRISC16_INSN_PUSHGR, CALMRISC16_INSN_PUSHAR, CALMRISC16_INSN_BITR, CALMRISC16_INSN_BITS
 , CALMRISC16_INSN_BITC, CALMRISC16_INSN_BITT, CALMRISC16_INSN_CMPGEGR, CALMRISC16_INSN_CMPGTGR
 , CALMRISC16_INSN_CMPUGEGR, CALMRISC16_INSN_CMPUGTGR, CALMRISC16_INSN_CMPEQGR, CALMRISC16_INSN_CMPGEGRIMM6
 , CALMRISC16_INSN_CMPEQGRIMM8, CALMRISC16_INSN_CMPGEI16, CALMRISC16_INSN_CMPGTI16, CALMRISC16_INSN_CMPUGEI16
 , CALMRISC16_INSN_CMPUGTI16, CALMRISC16_INSN_CMPEQI16, CALMRISC16_INSN_CMPEQARAR, CALMRISC16_INSN_CMPEQA22
 , CALMRISC16_INSN_BRAEXT, CALMRISC16_INSN_BRADEXT, CALMRISC16_INSN_BRA, CALMRISC16_INSN_BRAD
 , CALMRISC16_INSN_BRT, CALMRISC16_INSN_BRTD, CALMRISC16_INSN_BRF, CALMRISC16_INSN_BRFD
 , CALMRISC16_INSN_BNZD, CALMRISC16_INSN_JPFAI, CALMRISC16_INSN_JPFIMM22, CALMRISC16_INSN_JPTAI
 , CALMRISC16_INSN_JPTIMM22, CALMRISC16_INSN_JMPAI, CALMRISC16_INSN_JMPIMM22, CALMRISC16_INSN_JSRAI
 , CALMRISC16_INSN_JSRIMM22, CALMRISC16_INSN_BSRD, CALMRISC16_INSN_RETD, CALMRISC16_INSN_SWI
 , CALMRISC16_INSN_RETFIQ, CALMRISC16_INSN_RETIRQ, CALMRISC16_INSN_RET_SWI, CALMRISC16_INSN_BREAK
 , CALMRISC16_INSN_NOP, CALMRISC16_INSN_CLDR, CALMRISC16_INSN_CLDW, CALMRISC16_INSN_COP
 , CALMRISC16_INSN_SYS, CALMRISC16_INSN_MAX
} CGEN_INSN_TYPE;

/* Index of `invalid' insn place holder.  */
#define CGEN_INSN_INVALID CALMRISC16_INSN_INVALID

/* Total number of insns in table.  */
#define MAX_INSNS ((int) CALMRISC16_INSN_MAX)

/* This struct records data prior to insertion or after extraction.  */
struct cgen_fields
{
  int length;
  long f_nil;
  long f_anyof;
  long f_op1;
  long f_op2;
  long f_op3;
  long f_op4;
  long f_op0_3;
  long f_op4_1;
  long f_op4_3;
  long f_op8_1;
  long f_op8_2;
  long f_op8_3;
  long f_op9_1;
  long f_op12_1;
  long f_Rn;
  long f_Rn1;
  long f_Rm;
  long f_Dn;
  long f_Dn1;
  long f_H;
  long f_Rlist_Rm;
  long f_Rlist_Rn;
  long f_Rlist;
  long f_En;
  long f_An;
  long f_An1;
  long f_An2;
  long f_Alist_Am;
  long f_Alist_An;
  long f_Alist;
  long f_Rs;
  long f_imm5;
  long f_imm5c;
  long f_imm6;
  long f_imm7;
  long f_imm8;
  long f_imm13;
  long f_imm16;
  long f_imm22;
  long f_disp4;
  long f_disp8;
  long f_eoffset8;
  long f_eoffset11;
  long f_eoffset13;
  long f_edisp5;
  long f_edisp9;
  long f_disp16;
  long f_cmode1;
  long f_cmode2;
  long f_bmode;
  long f_d;
  long f_bs3;
  long f_ec2;
};

#define CGEN_INIT_PARSE(od) \
{\
}
#define CGEN_INIT_INSERT(od) \
{\
}
#define CGEN_INIT_EXTRACT(od) \
{\
}
#define CGEN_INIT_PRINT(od) \
{\
}


#endif /* CALMRISC16_OPC_H */
