/* Decode header for calmrisc16bf.

THIS FILE IS MACHINE GENERATED WITH CGEN.

Copyright (C) 1996, 1997, 1998, 1999, 2000 Free Software Foundation, Inc.

This file is part of the GNU Simulators.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

*/

#ifndef CALMRISC16BF_DECODE_H
#define CALMRISC16BF_DECODE_H

extern const IDESC *calmrisc16bf_decode (SIM_CPU *, IADDR,
                                  CGEN_INSN_INT, CGEN_INSN_INT,
                                  ARGBUF *);
extern void calmrisc16bf_init_idesc_table (SIM_CPU *);
extern void calmrisc16bf_sem_init_idesc_table (SIM_CPU *);
extern void calmrisc16bf_semf_init_idesc_table (SIM_CPU *);

/* Enum declaration for instructions in cpu family calmrisc16bf.  */
typedef enum calmrisc16bf_insn_type {
  CALMRISC16BF_INSN_X_INVALID, CALMRISC16BF_INSN_X_AFTER, CALMRISC16BF_INSN_X_BEFORE, CALMRISC16BF_INSN_X_CTI_CHAIN
 , CALMRISC16BF_INSN_X_CHAIN, CALMRISC16BF_INSN_X_BEGIN, CALMRISC16BF_INSN_CLRSRFE, CALMRISC16BF_INSN_SETSRFE
 , CALMRISC16BF_INSN_TSTSRFE, CALMRISC16BF_INSN_CLRSRIE, CALMRISC16BF_INSN_SETSRIE, CALMRISC16BF_INSN_TSTSRIE
 , CALMRISC16BF_INSN_CLRSRTE, CALMRISC16BF_INSN_SETSRTE, CALMRISC16BF_INSN_TSTSRTE, CALMRISC16BF_INSN_CLRSRV
 , CALMRISC16BF_INSN_SETSRV, CALMRISC16BF_INSN_TSTSRV, CALMRISC16BF_INSN_CLRSRZ0, CALMRISC16BF_INSN_SETSRZ0
 , CALMRISC16BF_INSN_TSTSRZ0, CALMRISC16BF_INSN_CLRSRZ1, CALMRISC16BF_INSN_SETSRZ1, CALMRISC16BF_INSN_TSTSRZ1
 , CALMRISC16BF_INSN_CLRSRPM, CALMRISC16BF_INSN_SETSRPM, CALMRISC16BF_INSN_TSTSRPM, CALMRISC16BF_INSN_ADDGRGR
 , CALMRISC16BF_INSN_SUBGRGR, CALMRISC16BF_INSN_ADDGRGRC, CALMRISC16BF_INSN_SUBGRGRC, CALMRISC16BF_INSN_MULUU
 , CALMRISC16BF_INSN_MULUS, CALMRISC16BF_INSN_MULSU, CALMRISC16BF_INSN_MULSS, CALMRISC16BF_INSN_ADDGRI7
 , CALMRISC16BF_INSN_SUBGRI7, CALMRISC16BF_INSN_ADDGRI16, CALMRISC16BF_INSN_ADDGRI16C, CALMRISC16BF_INSN_SUBGRI16C
 , CALMRISC16BF_INSN_ADDARGR, CALMRISC16BF_INSN_SUBARGR, CALMRISC16BF_INSN_ADDARI5, CALMRISC16BF_INSN_SUBARI5
 , CALMRISC16BF_INSN_ADDARI16, CALMRISC16BF_INSN_SUBARI16, CALMRISC16BF_INSN_COM, CALMRISC16BF_INSN_COM2
 , CALMRISC16BF_INSN_COMC, CALMRISC16BF_INSN_DECC, CALMRISC16BF_INSN_INCC, CALMRISC16BF_INSN_DT
 , CALMRISC16BF_INSN_EXT, CALMRISC16BF_INSN_RR, CALMRISC16BF_INSN_SR, CALMRISC16BF_INSN_SRA
 , CALMRISC16BF_INSN_SRB, CALMRISC16BF_INSN_SLB, CALMRISC16BF_INSN_RRC, CALMRISC16BF_INSN_RL
 , CALMRISC16BF_INSN_ANDGRGR, CALMRISC16BF_INSN_ORGRGR, CALMRISC16BF_INSN_XORGRGR, CALMRISC16BF_INSN_TSTGRGR
 , CALMRISC16BF_INSN_ANDGRI8, CALMRISC16BF_INSN_ORGRI8, CALMRISC16BF_INSN_XORGRI8, CALMRISC16BF_INSN_TSTGRI8
 , CALMRISC16BF_INSN_ANDGRI16, CALMRISC16BF_INSN_ORGRI16, CALMRISC16BF_INSN_XORGRI16, CALMRISC16BF_INSN_TSTGRI16
 , CALMRISC16BF_INSN_LDWARJ, CALMRISC16BF_INSN_LDAARJ, CALMRISC16BF_INSN_LDWAEDISP5, CALMRISC16BF_INSN_LDAAEDISP5
 , CALMRISC16BF_INSN_LDWSPEDISP9, CALMRISC16BF_INSN_LDW_GR_A_DISP16, CALMRISC16BF_INSN_LDW_AR_A_DISP16, CALMRISC16BF_INSN_LDBARJ
 , CALMRISC16BF_INSN_LDBADISP4, CALMRISC16BF_INSN_LDBA8DISP8, CALMRISC16BF_INSN_LDBADISP16, CALMRISC16BF_INSN_LDENDI
 , CALMRISC16BF_INSN_LDDNEI, CALMRISC16BF_INSN_LDRNRI, CALMRISC16BF_INSN_LDANAI, CALMRISC16BF_INSN_LDANPC
 , CALMRISC16BF_INSN_LDR0SRX, CALMRISC16BF_INSN_LDSRXR0, CALMRISC16BF_INSN_LDSRR0, CALMRISC16BF_INSN_LDR0SR
 , CALMRISC16BF_INSN_LDI8, CALMRISC16BF_INSN_LDI16, CALMRISC16BF_INSN_LDA22, CALMRISC16BF_INSN_POPGR
 , CALMRISC16BF_INSN_POPAR, CALMRISC16BF_INSN_LDC, CALMRISC16BF_INSN_STWARJ, CALMRISC16BF_INSN_STAARJ
 , CALMRISC16BF_INSN_STWAEDISP5, CALMRISC16BF_INSN_STAAEDISP5, CALMRISC16BF_INSN_STWSPEDISP9, CALMRISC16BF_INSN_STWADISP16
 , CALMRISC16BF_INSN_STW_AR_A_DISP16, CALMRISC16BF_INSN_STBARM, CALMRISC16BF_INSN_STBADISP4, CALMRISC16BF_INSN_STBA8DISP8
 , CALMRISC16BF_INSN_STBADISP16, CALMRISC16BF_INSN_PUSHGR, CALMRISC16BF_INSN_PUSHAR, CALMRISC16BF_INSN_BITR
 , CALMRISC16BF_INSN_BITS, CALMRISC16BF_INSN_BITC, CALMRISC16BF_INSN_BITT, CALMRISC16BF_INSN_CMPGEGR
 , CALMRISC16BF_INSN_CMPGTGR, CALMRISC16BF_INSN_CMPUGEGR, CALMRISC16BF_INSN_CMPUGTGR, CALMRISC16BF_INSN_CMPEQGR
 , CALMRISC16BF_INSN_CMPGEGRIMM6, CALMRISC16BF_INSN_CMPEQGRIMM8, CALMRISC16BF_INSN_CMPGEI16, CALMRISC16BF_INSN_CMPGTI16
 , CALMRISC16BF_INSN_CMPUGEI16, CALMRISC16BF_INSN_CMPUGTI16, CALMRISC16BF_INSN_CMPEQI16, CALMRISC16BF_INSN_CMPEQARAR
 , CALMRISC16BF_INSN_CMPEQA22, CALMRISC16BF_INSN_BRAEXT, CALMRISC16BF_INSN_BRADEXT, CALMRISC16BF_INSN_BRA
 , CALMRISC16BF_INSN_BRAD, CALMRISC16BF_INSN_BRT, CALMRISC16BF_INSN_BRTD, CALMRISC16BF_INSN_BRF
 , CALMRISC16BF_INSN_BRFD, CALMRISC16BF_INSN_BNZD, CALMRISC16BF_INSN_JPFAI, CALMRISC16BF_INSN_JPFIMM22
 , CALMRISC16BF_INSN_JPTAI, CALMRISC16BF_INSN_JPTIMM22, CALMRISC16BF_INSN_JMPAI, CALMRISC16BF_INSN_JMPIMM22
 , CALMRISC16BF_INSN_JSRAI, CALMRISC16BF_INSN_JSRIMM22, CALMRISC16BF_INSN_BSRD, CALMRISC16BF_INSN_RETD
 , CALMRISC16BF_INSN_SWI, CALMRISC16BF_INSN_RETFIQ, CALMRISC16BF_INSN_RETIRQ, CALMRISC16BF_INSN_RET_SWI
 , CALMRISC16BF_INSN_BREAK, CALMRISC16BF_INSN_NOP, CALMRISC16BF_INSN_CLDR, CALMRISC16BF_INSN_CLDW
 , CALMRISC16BF_INSN_COP, CALMRISC16BF_INSN_SYS, CALMRISC16BF_INSN_MAX
} CALMRISC16BF_INSN_TYPE;

/* Enum declaration for semantic formats in cpu family calmrisc16bf.  */
typedef enum calmrisc16bf_sfmt_type {
  CALMRISC16BF_SFMT_EMPTY, CALMRISC16BF_SFMT_CLRSRFE, CALMRISC16BF_SFMT_TSTSRFE, CALMRISC16BF_SFMT_CLRSRIE
 , CALMRISC16BF_SFMT_TSTSRIE, CALMRISC16BF_SFMT_CLRSRTE, CALMRISC16BF_SFMT_TSTSRTE, CALMRISC16BF_SFMT_CLRSRV
 , CALMRISC16BF_SFMT_TSTSRV, CALMRISC16BF_SFMT_CLRSRZ0, CALMRISC16BF_SFMT_TSTSRZ0, CALMRISC16BF_SFMT_CLRSRZ1
 , CALMRISC16BF_SFMT_TSTSRZ1, CALMRISC16BF_SFMT_CLRSRPM, CALMRISC16BF_SFMT_TSTSRPM, CALMRISC16BF_SFMT_ADDGRGR
 , CALMRISC16BF_SFMT_ADDGRGRC, CALMRISC16BF_SFMT_MULUU, CALMRISC16BF_SFMT_ADDGRI7, CALMRISC16BF_SFMT_ADDGRI16
 , CALMRISC16BF_SFMT_ADDGRI16C, CALMRISC16BF_SFMT_ADDARGR, CALMRISC16BF_SFMT_ADDARI5, CALMRISC16BF_SFMT_ADDARI16
 , CALMRISC16BF_SFMT_COM, CALMRISC16BF_SFMT_COMC, CALMRISC16BF_SFMT_DECC, CALMRISC16BF_SFMT_DT
 , CALMRISC16BF_SFMT_EXT, CALMRISC16BF_SFMT_RR, CALMRISC16BF_SFMT_RRC, CALMRISC16BF_SFMT_ANDGRGR
 , CALMRISC16BF_SFMT_TSTGRGR, CALMRISC16BF_SFMT_ANDGRI8, CALMRISC16BF_SFMT_TSTGRI8, CALMRISC16BF_SFMT_ANDGRI16
 , CALMRISC16BF_SFMT_TSTGRI16, CALMRISC16BF_SFMT_LDWARJ, CALMRISC16BF_SFMT_LDAARJ, CALMRISC16BF_SFMT_LDWAEDISP5
 , CALMRISC16BF_SFMT_LDAAEDISP5, CALMRISC16BF_SFMT_LDWSPEDISP9, CALMRISC16BF_SFMT_LDW_GR_A_DISP16, CALMRISC16BF_SFMT_LDW_AR_A_DISP16
 , CALMRISC16BF_SFMT_LDBARJ, CALMRISC16BF_SFMT_LDBADISP4, CALMRISC16BF_SFMT_LDBA8DISP8, CALMRISC16BF_SFMT_LDBADISP16
 , CALMRISC16BF_SFMT_LDENDI, CALMRISC16BF_SFMT_LDDNEI, CALMRISC16BF_SFMT_LDRNRI, CALMRISC16BF_SFMT_LDANAI
 , CALMRISC16BF_SFMT_LDANPC, CALMRISC16BF_SFMT_LDR0SRX, CALMRISC16BF_SFMT_LDSRXR0, CALMRISC16BF_SFMT_LDSRR0
 , CALMRISC16BF_SFMT_LDR0SR, CALMRISC16BF_SFMT_LDI8, CALMRISC16BF_SFMT_LDI16, CALMRISC16BF_SFMT_LDA22
 , CALMRISC16BF_SFMT_POPGR, CALMRISC16BF_SFMT_LDC, CALMRISC16BF_SFMT_STWARJ, CALMRISC16BF_SFMT_STAARJ
 , CALMRISC16BF_SFMT_STWAEDISP5, CALMRISC16BF_SFMT_STAAEDISP5, CALMRISC16BF_SFMT_STWSPEDISP9, CALMRISC16BF_SFMT_STWADISP16
 , CALMRISC16BF_SFMT_STW_AR_A_DISP16, CALMRISC16BF_SFMT_STBARM, CALMRISC16BF_SFMT_STBADISP4, CALMRISC16BF_SFMT_STBA8DISP8
 , CALMRISC16BF_SFMT_STBADISP16, CALMRISC16BF_SFMT_BITR, CALMRISC16BF_SFMT_BITT, CALMRISC16BF_SFMT_CMPGEGRIMM6
 , CALMRISC16BF_SFMT_CMPEQGRIMM8, CALMRISC16BF_SFMT_CMPEQARAR, CALMRISC16BF_SFMT_CMPEQA22, CALMRISC16BF_SFMT_BRAEXT
 , CALMRISC16BF_SFMT_BRA, CALMRISC16BF_SFMT_BRT, CALMRISC16BF_SFMT_BNZD, CALMRISC16BF_SFMT_JPFAI
 , CALMRISC16BF_SFMT_JPFIMM22, CALMRISC16BF_SFMT_JMPAI, CALMRISC16BF_SFMT_JMPIMM22, CALMRISC16BF_SFMT_JSRAI
 , CALMRISC16BF_SFMT_JSRIMM22, CALMRISC16BF_SFMT_BSRD, CALMRISC16BF_SFMT_RETD, CALMRISC16BF_SFMT_SWI
 , CALMRISC16BF_SFMT_RETFIQ, CALMRISC16BF_SFMT_RETIRQ, CALMRISC16BF_SFMT_RET_SWI, CALMRISC16BF_SFMT_CLDR
} CALMRISC16BF_SFMT_TYPE;

/* Function unit handlers (user written).  */

extern int calmrisc16bf_model_calmrisc16_u_exec (SIM_CPU *, const IDESC *, int /*unit_num*/, int /*referenced*/);

/* Profiling before/after handlers (user written) */

extern void calmrisc16bf_model_insn_before (SIM_CPU *, int /*first_p*/);
extern void calmrisc16bf_model_insn_after (SIM_CPU *, int /*last_p*/, int /*cycles*/);

#endif /* CALMRISC16BF_DECODE_H */
